import java.io.File;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Enumeration;
import java.util.List;
import java.util.Vector;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;

import gov.nih.nci.system.client.ApplicationServiceProvider;
import gov.nih.nci.system.applicationservice.*;
//import gov.nih.nci.system.applicationservice.impl.*;
import gov.nih.nci.evs.query.*;
import gov.nih.nci.evs.domain.*;
import gov.nih.nci.evs.security.*;



public class TestClient
{
	//String url = "http://cbvapp-d1007.nci.nih.gov:19080/evsapi40";
	String url = "http://localhost:8080/evsapi40";
	
	// GF# 14545
	String _service = "EvsServiceInfo";
	
	public static void main(String args[])
	{
		TestClient client = new TestClient();
		try
		{
			client.testSearch();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	public void testSearch() throws Exception
	{
		//EVSApplicationService appService = (EVSApplicationService)ApplicationServiceProvider.getApplicationService();
		EVSApplicationService appService = (EVSApplicationService) ApplicationServiceProvider.getApplicationServiceFromUrl(url, _service);
			try
			{
				DescLogicConcept dlc = new DescLogicConcept();
				//dlc.setName("ear*");
				//dlc.setName("C191");
				dlc.setCode("C9440"); // Abnormality
				Collection results = appService.search("gov.nih.nci.evs.domain.DescLogicConcept", dlc);
                System.out.println("Results: "+ results.size());
				for(Object o : results)				{
                    DescLogicConcept obj = (DescLogicConcept)o;
                    System.out.println("Concept name : "+ obj.getName() +"\t"+ obj.getCode());
                    Vector propList = (Vector)obj.getPropertyCollection();
                    if(propList == null){
                        System.out.println("No properties found");
                    }else{
                        System.out.println("Properties: "+ propList.size());
                    }
                    Vector roleList = (Vector) obj.getRoleCollection();
                    if(roleList == null){
                        System.out.println("No roles found");
                    }else{
                        System.out.println("Roles: "+ roleList.size());
                    }

				}
			}catch(Exception e)
			{
				System.out.println(">>>"+e.getMessage());
                e.printStackTrace();
			}



			try
			{
				MetaThesaurusConcept dlc = new MetaThesaurusConcept();
				//dlc.setName("ear*");
				//dlc.setName("C191");
				//dlc.setCui("C0151583");
				dlc.setCui("C1704258");
				Collection results = appService.search("gov.nih.nci.evs.domain.MetaThesaurusConcept", dlc);
                System.out.println("Results: "+ results.size());
				for(Object o : results)				{
                    MetaThesaurusConcept obj = (MetaThesaurusConcept)o;
                    System.out.println("Concept name : "+ obj.getName() +"\t"+ obj.getCui());
                    ArrayList propList = (ArrayList)obj.getSynonymCollection();
                    if(propList == null){
                        System.out.println("No synonym found.");
                    }else{
                        System.out.println("Synonyms: "+ propList.size());
						for (int i=0; i<propList.size(); i++)
						{
							String s = (String) propList.get(i);
							System.out.println("Synonym: " + s);
						}
				    }
                    ArrayList semanticTypeList = (ArrayList) obj.getSemanticTypeCollection();
                    if(semanticTypeList == null){
                        System.out.println("No roles found");
                    }else{
                        System.out.println("Semantic Types: "+ semanticTypeList.size());
 						for (int i=0; i<semanticTypeList.size(); i++)
						{
							SemanticType s = (SemanticType) semanticTypeList.get(i);
							System.out.println("SemanticType: " + s.getName() + " (" + s.getId() + ")");
						}
                    }

				}
			}catch(Exception e)
			{
				System.out.println(">>>"+e.getMessage());
                e.printStackTrace();
			}

	}

	protected void printObject(Object obj, Class klass) throws Exception {
		System.out.println("Printing "+ obj.getClass().getName());
		Method[] methods = klass.getMethods();
		for(Method method:methods)
		{
			if(method.getName().startsWith("get") && !method.getName().equals("getClass"))
			{
				System.out.print("\t"+method.getName().substring(3)+":");
				Object val = method.invoke(obj, (Object[])null);
				if(val instanceof java.util.Set)
					System.out.println("size="+((Collection)val).size());
				else
					System.out.println(val);
			}
		}
	}


	protected Collection<Class> getClasses() throws Exception
	{
		Collection<Class> list = new ArrayList<Class>();
		JarFile file = null;
		int count = 0;

		File myfile = new File("lib");
		for(File f:myfile.listFiles())
		{
			if(f.getName().endsWith("-beans.jar"))
			{
				file = new JarFile(f);
				count++;
			}
		}
		if(file == null) throw new Exception("Could not locate the bean jar");
		if(count>1) throw new Exception("Found more than one bean jar");

		Enumeration e = file.entries();
		while(e.hasMoreElements())
		{
			JarEntry o = (JarEntry) e.nextElement();
			if(!o.isDirectory())
			{
				String name = o.getName();
				if(name.endsWith(".class"))
				{
					String klassName = name.replace('/', '.').substring(0, name.lastIndexOf('.'));
					list.add(Class.forName(klassName));
				}
			}
		}
		return list;
	}
}