package gov.nih.nci.system.applicationservice;

import gov.nih.nci.evs.query.EVSQuery;

import java.util.List;

import org.LexGrid.LexBIG.LexBIGService.LexBIGService;


import java.util.HashMap;
import gov.nih.nci.evs.security.SecurityToken;
/**
 * ApplicationService interface for EVS.
 *
 * @author <a href="mailto:muhsins@mail.nih.gov">Shaziya Muhsin</a>
 * @author <a href="mailto:rokickik@mail.nih.gov">Konrad Rokicki</a>
 */
public interface EVSApplicationService extends ApplicationService,
        LexBIGService {

    /**
     * Evs search.
     *
     * @param evsQuery the evs query
     *
     * @return the list< object>
     *
     * @throws Exception the exception
     */
    public List<Object> evsSearch(EVSQuery evsQuery) throws Exception;


    /* (non-Javadoc)
     * @see gov.nih.nci.system.applicationservice.ApplicationService#search(java.lang.String, java.lang.Object)
     */
    public List<Object> search(String searchClass, Object criteria)
            throws ApplicationException;

    /**
     * Execute remotely.
     *
     * @param object the object
     * @param methodName the method name
     * @param parameterClasses the parameter classes
     * @param args the args
     *
     * @return the object
     *
     * @throws Exception the exception
     */
    public Object executeRemotely(Object object, String methodName,
                    String[] parameterClasses, Object[] args)
                    throws Exception;


    public HashMap getSecurityToken_map();

    public List<Object> getAssociation(Object source, String associationName, SecurityToken securityToken) throws Exception;

}
