package gov.nih.nci.system.dao.evs;

import gov.nih.nci.evs.domain.Association;
import gov.nih.nci.evs.domain.Atom;
import gov.nih.nci.evs.domain.DescLogicConcept;
import gov.nih.nci.evs.domain.History;
import gov.nih.nci.evs.domain.HistoryRecord;
import gov.nih.nci.evs.domain.MetaThesaurusConcept;
import gov.nih.nci.evs.domain.Property;
import gov.nih.nci.evs.domain.Qualifier;
import gov.nih.nci.evs.domain.Role;
import gov.nih.nci.evs.domain.SemanticType;
import gov.nih.nci.evs.domain.Source;
import gov.nih.nci.evs.domain.Vocabulary;
import gov.nih.nci.evs.query.EVSQuery;
import gov.nih.nci.evs.query.EVSQueryImpl;
import gov.nih.nci.evs.security.SecurityToken;
import gov.nih.nci.system.dao.DAO;
import gov.nih.nci.system.dao.Request;
import gov.nih.nci.system.dao.Response;

import java.io.InputStream;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;
import java.util.Set;
import java.util.Vector;

import org.apache.log4j.Logger;

/**
 * <!-- LICENSE_TEXT_START -->
 The caBIO Software License, Version 3.1 Copyright 2001-2006 Science Applications International Corporation (SAIC)
 Copyright Notice.  The software subject to this notice and license includes both human readable source code form and machine readable, binary, object code form (the caBIO Software).  The caBIO Software was developed in conjunction with the National Cancer Institute (NCI) by NCI employees and employees of SAIC.  To the extent government employees are authors, any rights in such works shall be subject to Title 17 of the United States Code, section 105.
 This caBIO Software License (the License) is between NCI and You.  You (or Your) shall mean a person or an entity, and all other entities that control, are controlled by, or are under common control with the entity.  Control for purposes of this definition means (i) the direct or indirect power to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity.
 This License is granted provided that You agree to the conditions described below.  NCI grants You a non-exclusive, worldwide, perpetual, fully-paid-up, no-charge, irrevocable, transferable and royalty-free right and license in its rights in the caBIO Software to (i) use, install, access, operate, execute, copy, modify, translate, market, publicly display, publicly perform, and prepare derivative works of the caBIO Software; (ii) distribute and have distributed to and by third parties the caBIO Software and any modifications and derivative works thereof; and (iii) sublicense the foregoing rights set out in (i) and (ii) to third parties, including the right to license such rights to further third parties.  For sake of clarity, and not by way of limitation, NCI shall have no right of accounting or right of payment from You or Your sublicensees for the rights granted under this License.  This License is granted at no charge to You.
 1.	Your redistributions of the source code for the Software must retain the above copyright notice, this list of conditions and the disclaimer and limitation of liability of Article 6, below.  Your redistributions in object code form must reproduce the above copyright notice, this list of conditions and the disclaimer of Article 6 in the documentation and/or other materials provided with the distribution, if any.
 2.	Your end-user documentation included with the redistribution, if any, must include the following acknowledgment: This product includes software developed by SAIC and the National Cancer Institute.  If You do not include such end-user documentation, You shall include this acknowledgment in the Software itself, wherever such third-party acknowledgments normally appear.
 3.	You may not use the names "The National Cancer Institute", "NCI" Science Applications International Corporation and "SAIC" to endorse or promote products derived from this Software.  This License does not authorize You to use any trademarks, service marks, trade names, logos or product names of either NCI or SAIC, except as required to comply with the terms of this License.
 4.	For sake of clarity, and not by way of limitation, You may incorporate this Software into Your proprietary programs and into any third party proprietary programs.  However, if You incorporate the Software into third party proprietary programs, You agree that You are solely responsible for obtaining any permission from such third parties required to incorporate the Software into such third party proprietary programs and for informing Your sublicensees, including without limitation Your end-users, of their obligation to secure any required permissions from such third parties before incorporating the Software into such third party proprietary software programs.  In the event that You fail to obtain such permissions, You agree to indemnify NCI for any claims against NCI by such third parties, except to the extent prohibited by law, resulting from Your failure to obtain such permissions.
 5.	For sake of clarity, and not by way of limitation, You may add Your own copyright statement to Your modifications and to the derivative works, and You may provide additional or different license terms and conditions in Your sublicenses of modifications of the Software, or any derivative works of the Software as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License.
 6.	THIS SOFTWARE IS PROVIDED "AS IS," AND ANY EXPRESSED OR IMPLIED WARRANTIES, (INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE) ARE DISCLAIMED.  IN NO EVENT SHALL THE NATIONAL CANCER INSTITUTE, SAIC, OR THEIR AFFILIATES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 * <!-- LICENSE_TEXT_END -->
 */
/**
 * @author Shaziya Muhsin
 */

/**
 * The EVSWebServices class describes methods implemented to query the
 * Enterprise Vocabulary Service.
 */




/**
 * The Class EVSWSDAOImpl.
 */
@SuppressWarnings("all")
public class EVSWSDAOImpl implements DAO {
	
	/** The log. */
	private static Logger log = Logger.getLogger(EVSWSDAOImpl.class.getName());

	/** The default vocabulary. */
	private String defaultVocabulary = "NCI_Thesaurus";
	
	/** The default limit. */
	private int defaultLimit = 200;
	
	/** The return class name. */
	private String returnClassName;
    
    /** The security token. */
    SecurityToken securityToken = null;
    
    /** The evs properties. */
    private Properties evsProperties = new Properties();
    
    /** The file name. */
    private String fileName = "evsBeans.properties";
    
    /** The config. */
    private Hashtable config = new Hashtable();
    
    /** The limit. */
    private int limit = 200;
//    private static HashMap vocab = new HashMap();

	/**
 * Instantiates a new eVSWSDAO impl.
 * 
 * @param evsFileName the evs file name
 */
EVSWSDAOImpl(String evsFileName){
	    fileName = evsFileName;
    }

	/**
	 * /**
	 * Returns a List of records from the Metathesaurus.
	 * 
	 * @param atomList the atom list
	 * @param sourceAbbr the source abbr
	 * 
	 * @return the list
	 * 
	 * @throws Exception the exception
	 */

 /*
    private List searchMetaphrase(Object criteria)
            throws Exception {
        String conceptName = null;
        String conceptCode = null;
        List sourceList = new ArrayList();
        String source = "*";
        List atomList = new ArrayList();
        try {
            if(criteria.getClass().getName().endsWith("MetaThesaurusConcept")){
                MetaThesaurusConcept metaConcept = (MetaThesaurusConcept)criteria;
                conceptName = metaConcept.getName();
                conceptCode = metaConcept.getCui();
                if (metaConcept.getSourceCollection() != null) {
                    sourceList = metaConcept.getSourceCollection();
                    if (sourceList.size() > 0) {
                        if(sourceList.get(0)!=null){
                            source = ((Source) sourceList.get(0)).getAbbreviation();
                        }
                    }
                }
                if (metaConcept.getAtomCollection() != null) {
                    atomList = metaConcept.getAtomCollection();
                }
            }
            else if(criteria.getClass().getName().endsWith("Atom")){
                atomList.add(criteria);
                Atom atom = (Atom)criteria;
                try{
                	if(atom.getSource()!= null){
                        source = atom.getSource().getAbbreviation();
                    }
                }
                catch(Exception ex){
                	log.error("Exception thrown in Atom: "+ex.getMessage());
                }
            }
            else if(criteria.getClass().getName().endsWith("Source")){
                source = ((Source)criteria).getAbbreviation();
            }
        } catch (Exception e) {
            throw new Exception("Exception while processing MetaThesaurusConcept - "+e.getMessage());
        }
        EVSQuery evsQuery = new EVSQueryImpl();
        List results = new ArrayList();
        try {
            if (conceptName == null && conceptCode == null && atomList.size()>0) {
                results =  searchByAtoms(atomList, source);
                }
            else{
                if (conceptCode != null && source == null) {
                    evsQuery.searchMetaThesaurus(conceptCode);
                } else if (conceptCode != null && source != null) {
                    evsQuery.searchMetaThesaurus(conceptCode, defaultLimit, source,
                            true, false, true);
                } else if (conceptName != null) {
                    evsQuery.searchMetaThesaurus(conceptName, defaultLimit, source,
                            false, false, true);
                }else{
                    throw new Exception("Invalid search criteria");
                }
                results = query(evsQuery);
            }


        } catch (Exception e) {
            throw new Exception(e.getMessage());
        }
        return results;

    }

    */
    /**
     * Performs search on the MetaThesaurus by atoms
     * @param atomList
     * @param sourceAbbr
     * @return returns a list of MetaThesaurusConcepts or Atoms based on the specified return type
     * @throws Exception
     */
    private List searchByAtoms(List atomList, String sourceAbbr) throws Exception{
        List resultSet = new ArrayList();
        List conceptList = new ArrayList();
        HashMap atomSet = new HashMap();
        HashMap metaSet = new HashMap();
        String code = null;
        String name = null;
        String origin = null;
        String source = null;
        for(int i=0; i<atomList.size(); i++){
            Atom atom = (Atom) atomList.get(i);
            if(atom.getCode() != null){
                code = atom.getCode();
            }
            if(atom.getName()!= null){
                name = atom.getName();
            }
            if(atom.getOrigin()!=null){
                try{
                    origin = atom.getOrigin();
                    if(origin.indexOf("/")>0){
                        source = origin.substring(0, origin.indexOf("/"));
                    }else{
                        source = origin;
                    }
                }catch(Exception ex){
                    throw new Exception("Atom: "+ex.getMessage());
                }
            }
            if (source == null) {
                if(atom.getSource()!= null){
                    try{
                        source = atom.getSource().getAbbreviation();
                    }catch(Exception ex){
                        log.error(ex.getMessage());
                    }
                }
                if(source == null){
                    source = sourceAbbr;
                }
            }
            EVSQuery evsQuery = new EVSQueryImpl();

            //if(code != null && source == null){
			if(code != null && source != null){

//				evsQuery.searchSourceByCode(code, source);
				evsQuery.searchSourceByAtomCode(code, source);
				//return new ArrayList(query(evsQuery));

                //evsQuery.searchSourceByCode(code, source);
                //evsQuery.searchMetaThesaurus(code, defaultLimit, null, true, false, true);

            }else if(name != null && source != null){
                evsQuery.searchMetaThesaurus(name, defaultLimit, source,false, false, true);
            }else if(name != null && source == null){
                evsQuery.searchMetaThesaurus(name, defaultLimit, "*",false, false, true);
            }else if(code != null && source == null){
                evsQuery.searchSourceByAtomCode(code, "*");
            }else {
                throw new Exception("Invalid search criteria - please specify atom name or code");
            }


            conceptList = query(evsQuery);
            if(source != null){
                if(source.equals("*")){
                    source = null;
                }
            }

           if(returnClassName.endsWith("Atom")){
                for(int y=0; y<conceptList.size();y++){
                    List atoms = ((MetaThesaurusConcept)conceptList.get(y)).getAtomCollection();
                    for(int a=0; a<atoms.size(); a++){
                        Atom atomConcept = (Atom)atoms.get(a);
                        String atomCode = atomConcept.getCode();
                        String atomOrigin = atomConcept.getOrigin();
                        if(code != null && source != null){
                            if(atomOrigin.startsWith(source) && code.equals(atomCode)){
                                atomSet.put(source + atomCode, atomConcept);
                            }
                        }else if(code != null && source == null){
                            if(code.equals(atomCode)){
                                atomSet.put(atomCode, atomConcept);
                            }
                        }else if(code == null && source != null){
                            if(atomOrigin.startsWith(source)){
                                atomSet.put(source + atomCode, atomConcept);
                            }
                        }else if(atomConcept.getName()!=null && source != null && !source.equals("*")){
                            String srcAbbr = atomOrigin;
                            if(atomConcept.getSource()!= null){
                                if(atomConcept.getSource().getAbbreviation()!=null)
                                    srcAbbr = atomConcept.getSource().getAbbreviation();
                            }
                            if(srcAbbr != null){
                                if(srcAbbr.equalsIgnoreCase(source)){
                                    atomSet.put(srcAbbr + atomConcept.getName(), atomConcept);
                                }
                            }
                        }else if(atomConcept.getName()!=null){
                            atomSet.put(atomConcept.getName(), atomConcept);
                        }
                    }

                }
            }else{ // source
                for(int c=0; c<conceptList.size(); c++){
                    MetaThesaurusConcept mtc = (MetaThesaurusConcept) conceptList.get(c);
                    metaSet.put(mtc.getCui(), mtc);
                }
            }

        }
        if(atomSet.size()>0){
            for(Iterator iterator = atomSet.keySet().iterator(); iterator.hasNext();){
                String key = (String)iterator.next();
                resultSet.add(atomSet.get(key));
            }
        }else if(metaSet.size()>0){
            for(Iterator iterator = metaSet.keySet().iterator(); iterator.hasNext();){
                String key = (String)iterator.next();
                resultSet.add(metaSet.get(key));
            }
        }
        return resultSet;
    }

    /**
     * Returns a list of Description Logic vocabularies.
     * 
     * @return the vocabularies
     * 
     * @throws Exception the exception
     */

    private List getVocabularies() throws Exception{
      EVSQuery evsQuery = new EVSQueryImpl();
      evsQuery.getAllVocabularies();
      return query(evsQuery);
    }

    /**
     * Returns the specified vocabulary.
     * 
     * @param name the name
     * 
     * @return the vocabulary
     * 
     * @throws Exception the exception
     * 
     * @name specifies the vocabulary name
     */
    private List getVocabulary(String name) throws Exception{
        EVSQuery evsQuery = new EVSQueryImpl();
        evsQuery.getVocabularyByName(name);
        return query(evsQuery);
    }

    /**
     * Returns a list of Silos in the default vocabulary.
     * 
     * @return the all silos
     * 
     * @throws Exception the exception
     * 
     * @deprecated - evsapi4 no longer supports silos
     */@Deprecated
    private List getAllSilos() throws Exception{
        EVSQuery evsQuery = new EVSQueryImpl();
        evsQuery.getAllSilos(defaultVocabulary);
        return query(evsQuery);
    }



  /**
   * Returns a list of SemanticTypes for one or more MetaThesaurusConcepts specified in the list.
   * 
   * @param mtcList List of instance of gov.nih.nci.evs.domain.MetaThesaurusConcepts
   * 
   * @return the semantic types
   * 
   * @throws Exception the exception
   */
  private List getSemanticTypes(List mtcList)throws Exception{
      Set list = new HashSet();

      for(int i=0; i<mtcList.size(); i++){
          MetaThesaurusConcept mtc = (MetaThesaurusConcept)mtcList.get(i);
          List sList = mtc.getSemanticTypeCollection();
          for(int a=0; a< sList.size(); a++){
              list.add(sList.get(a));
          }
      }
      List semanticList = new ArrayList();
      semanticList.addAll(list);
      return semanticList;
  }
  
  /**
   * Returns a list of Sources for one or more MetaThesaurusConcepts specified in the list.
   * 
   * @param mtcList List of instance of gov.nih.nci.evs.domain.MetaThesaurusConcepts
   * 
   * @return the sources
   * 
   * @throws Exception the exception
   */
  private List getSources(List mtcList) throws Exception{
      Set list = new HashSet();

      for(int i=0; i<mtcList.size(); i++){
          MetaThesaurusConcept mtc = (MetaThesaurusConcept)mtcList.get(i);
          List sourceList = mtc.getSourceCollection();
          for(int a=0; a< sourceList.size(); a++){
              list.add(sourceList.get(a));
          }
      }
      List sources = new ArrayList();
      sources.addAll(list);
      return sources;
  }

  /**
   * Queries EVS vocabularies  and returns results.
   * 
   * @param evsQuery - specifies the EVSQuery
   * 
   * @return the list
   * 
   * @throws Exception the exception
   */

    private List query(EVSQuery evsQuery) throws Exception {
        List results = new ArrayList();
        if(securityToken != null){
            ((EVSQueryImpl)evsQuery).addSecurityToken(defaultVocabulary, securityToken);
        }
        try {
            EVSQueryDAOImpl dao = new EVSQueryDAOImpl();
            Request request = new Request(evsQuery);
            request.setConfig(config);
            request.setDomainObjectName(evsQuery.getClass().getName());
            Response response = dao.query(request);
            results = (List)response.getResponse();

        } catch (Exception ex) {
            ex.printStackTrace();
            throw new Exception(ex.getMessage());
        }
        return results;
    }


    /**
     * This method converts a DescLogicConcept to a matching MetaThesaurusConcept or a MetaThesaurusConcept to a matching
     * DescLogicConcept based on the contents of the conceptList.
     * 
     * @param concepts List of DescLogicConcepts or a List of MetaThesaurusConcepts
     * 
     * @return the list
     * 
     * @throws Exception the exception
     */
    private List convertConcepts(List concepts) throws Exception {
        List convertedResults = new ArrayList();
        Set results = new HashSet();
        if(!(concepts.size()>0)){
            return new ArrayList();
        }
        if (concepts.get(0).getClass().getName().endsWith("DescLogicConcept")) {
            for (int i = 0; i < concepts.size(); i++) {
                DescLogicConcept concept = (DescLogicConcept) concepts.get(i);

                String metaConceptCode = null;
                Vector properties = concept.getPropertyCollection();
                for (int p = 0; p < properties.size(); p++) {
                    Property property = (Property) properties.get(p);
                    if (property.getName().equals("NCI_META_CUI")
                            || property.getName().equals("UMLS_CUI")) {
                        metaConceptCode = property.getValue();
                        break;
                    }
                }
                EVSQuery metaSearch = new EVSQueryImpl();
                if (metaConceptCode != null) {
                    metaSearch.searchMetaThesaurus(metaConceptCode);
                    try {
                        List metaConcept = query(metaSearch);
                        if (metaConcept.size() > 0) {
                            results.add((MetaThesaurusConcept) metaConcept
                                    .get(0));
                        }
                    } catch (Exception ex) {
                    }

                } else {
                    EVSQuery q = new EVSQueryImpl();
                    q.getMetaSources();
                    List nciSource = new ArrayList();
                    List sourceList = new ArrayList();
                    sourceList = query(q);

                    for (int s = 0; s < sourceList.size(); s++) {
                        Source source = (Source) sourceList.get(s);
                        if (source.getAbbreviation().startsWith("NCI")) {
                            nciSource.add(source.getAbbreviation());
                        }
                    }
                    for (int x = 0; x < nciSource.size(); x++) {
                        String code = (String) nciSource.get(x);

                        metaSearch.searchSourceByAtomCode(concept.getCode(), code);
                        try {
                            List metaConcept = query(metaSearch);
                            if (metaConcept.size() > 0) {
                                results.add((MetaThesaurusConcept) metaConcept
                                        .get(0));
                            }
                        } catch (Exception ex) {
                            log.info("Exception: " + ex.getMessage());
                        }

                    }

                }

            }
        } else if (concepts.get(0).getClass().getName().endsWith(
                "MetaThesaurusConcept")) {
            for (int i = 0; i < concepts.size(); i++) {
                MetaThesaurusConcept mtc = (MetaThesaurusConcept) concepts
                        .get(i);
                String code = mtc.getCui();
                List dlcConcept = new ArrayList();
                List match = new ArrayList();
                if (code != null) {
                    EVSQuery evsQuery = new EVSQueryImpl();
                    evsQuery.searchDescLogicConcepts(defaultVocabulary, code,
                            1, 2, "NCI_META_CUI", 1);
                    dlcConcept = query(evsQuery);
                    if (dlcConcept.size() < 1) {
                        evsQuery = new EVSQueryImpl();
                        evsQuery.searchDescLogicConcepts(defaultVocabulary,
                                code, 1, 2, "UMLS_CUI", 1);
                        dlcConcept = query(evsQuery);
                    }
                    if (dlcConcept.size() < 1) {
                        ArrayList atomList = mtc.getAtomCollection();
                        for (int a = 0; a < atomList.size(); a++) {
                            Atom atom = (Atom) atomList.get(a);
                            Source source = atom.getSource();

                            if (source.getAbbreviation().startsWith("NCI")) {
                                String atomCode = atom.getCode();
                                evsQuery = new EVSQueryImpl();
//                                evsQuery.getDescLogicConcept(defaultVocabulary,
//                                        atomCode, true);
                                evsQuery.getDescLogicConcept(defaultVocabulary,
                                        atomCode);
                                try {
                                    match = query(evsQuery);

                                } catch (Exception ex) {
                                    log.error("Invalid concept" + atomCode);
                                }
                                if (match.size() > 0) {
                                    dlcConcept.add(match.get(0));
                                }
                            }
                        }
                    }
                    if (dlcConcept.size() > 0) {
                        results.add((DescLogicConcept) dlcConcept.get(0));
                    }
                }
            }
        }
        if (results.size() > 0) {
            for (Iterator i = results.iterator(); i.hasNext();) {
                convertedResults.add(i.next());
            }
        }
        return convertedResults;
    }


    /**
     * Loads properties from the given file.
     * 
     * @param l_fileName specify the properties file name
     * 
     * @throws Exception the exception
     */
    private void loadProperties(String l_fileName) throws Exception {

        if (evsProperties.size() < 1) {
            if (l_fileName != null) {
                try {
                    evsProperties
                            .load(Thread.currentThread()
                                    .getContextClassLoader()
                                    .getResourceAsStream(l_fileName));
                } catch (Exception ex) {
                    log.error("Cannot locate EVS properties file");
                }
            }

        }
    }

    /**
     * Locates and returns a fully qualified class name from a property file.
     * 
     * @param beanName - specify the class name
     * 
     * @return the string
     * 
     * @throws Exception the exception
     */
    public String locateClass(String beanName) throws Exception {
        String className = null;
//        boolean found = false;
        if (evsProperties == null) {
            loadProperties("evsBeans.properties");
        }
        if (evsProperties != null) {
            for (Iterator i = evsProperties.keySet().iterator(); i.hasNext();) {
                String key = (String) i.next();
                if (beanName.lastIndexOf(".") > 1) {
                    if (key.equals(className)) {
                        className = key;
                        break;
                    }
                } else {
                    if (key.substring(key.lastIndexOf(".") + 1)
                            .equals(beanName)) {
                        className = key;
                        break;
                    }
                }
            }
        }

        return className;
    }

/**
 * Returns all EVS Class names specified for this DAO.
 * 
 * @return the all class names
 */
    public List getAllClassNames(){
        List classNames = new ArrayList();
        if(fileName == null){
            fileName = "evsBeans.properties";
        }
        try{
            InputStream is = Thread.currentThread().getContextClassLoader().getResourceAsStream(fileName);
            if(is != null){
                evsProperties.load(is);
            }
            is.close();
            if(evsProperties.size()>0){
                for(Iterator it = evsProperties.keySet().iterator();it.hasNext();){
                    String key = (String)it.next();
                    classNames.add(key);
                }
            }
        }catch(Exception ex){
            log.error("Cannot locate file - "+ fileName + "\t"+ ex.getMessage());
        }
        return classNames;
    }

    /* (non-Javadoc)
     * @see gov.nih.nci.system.dao.DAO#query(gov.nih.nci.system.dao.Request)
     */
    public Response query(Request request)throws Exception{
        Object evsCriteria = request.getRequest();
        config = request.getConfig();
        String searchBean = null;
        if(config.get("searchClass")!=null){
            searchBean = (String)config.get("searchClass");
        }else{
            searchBean = request.getDomainObjectName();
        }
//        String searchClass = locateClass(searchBean);

        if(searchBean == null){
            searchBean = evsCriteria.getClass().getName();
        }
        List results = new ArrayList();
        try{
            results = getEVSResults(searchBean, evsCriteria);
        }catch(Exception e){
            throw new Exception("EVSWSDAOImpl error: "+ e);
        }
        return new Response(results);
    }


    /**
     * Search desc logic concepts.
     * 
     * @param dlc the dlc
     * 
     * @return the list
     * 
     * @throws Exception the exception
     */
    private List searchDescLogicConcepts(DescLogicConcept dlc) throws Exception{
        Field[] fields = dlc.getClass().getDeclaredFields();
        String code = null;
        String name = null;
        String vocabName = null;
        int matchOption = 0;
        String matchType = "";

        EVSQuery evsQuery = new EVSQueryImpl();

        for(Field f: fields){
            try{
                f.setAccessible(true);
                if(f.getName().equalsIgnoreCase("serialVersionUID")){
                    continue;
                }
                if(f.get(dlc)!=null){
                    if(f.getName().endsWith("Collection")){
                        Collection c = (Collection)f.get(dlc);
                        if(c.size()<=0){
                            continue;
                        }
                    }
                    if(f.getName().equals("code")){
                        code = (String)f.get(dlc);
                    }else if(f.getName().equalsIgnoreCase("name")){
                        name = (String)f.get(dlc);
                    }else if(f.getName().equalsIgnoreCase("Vocabulary")){
                        Vocabulary v = (Vocabulary)f.get(dlc);
                        if(v.getName()!= null){
                            vocabName = v.getName();
                        }
                    }else if(f.getName().equalsIgnoreCase("roleCollection")){
                        Vector rVector = (Vector)f.get(dlc);
                        matchOption = 1;
                        Role r = (Role)rVector.get(0);
                        if(r.getName()!=null){
                            matchType = r.getName();
                        }
                    }else if(f.getName().equalsIgnoreCase("propertyCollection")){
                        Vector pVector = (Vector)f.get(dlc);
                        matchOption = 2;
                        Property p = (Property) pVector.get(0);
                        if(p.getName() != null){
                            matchType = p.getName();
                        }
                    }else if(f.getName().equalsIgnoreCase("associationCollection")){
                        Vector aVector = (Vector)f.get(dlc);
                        matchOption = 4;
                        Association a = (Association) aVector.get(0);
                        if(a.getName() != null){
                            matchType = a.getName();
                        }
                    }else if(f.getName().equalsIgnoreCase("historyRecord")){
                        HistoryRecord hrec = (HistoryRecord)f.get(dlc);
                        code = hrec.getDescLogicConceptCode();
                    }
                    //Add History record
                    if(vocabName == null){
                        vocabName = this.defaultVocabulary;
                    }
                    if(code != null){
//                        evsQuery.getDescLogicConcept(vocabName, code, true);
                        evsQuery.getDescLogicConcept(vocabName, code);
                    }else if(name !=null && matchOption == 0){
                        evsQuery.searchDescLogicConcepts(vocabName,name, limit, 0,"",0);
                    }else if (matchOption > 0) {
                        if (matchType == null && name != null) {
                            evsQuery.searchDescLogicConcepts(vocabName,name, limit, matchOption ,"",0);
                        }else if (matchType != null && name == null){
                            evsQuery.searchDescLogicConcepts(vocabName,matchType, limit, matchOption ,matchType,0);
                        }
                    }else{
                        throw new Exception("Invalid search criteria - Specify concept code or name to query");
                    }

                    ///
                }
            }catch(Exception e){
                throw new Exception("Error reading DescLogicConcept "+ f.getName() +"\n"+ e);
            }

        }
        return query(evsQuery);
    }
    //=====================================

    /**
     * Search meta thesaurus concepts.
     * 
     * @param mtc the mtc
     * 
     * @return the list
     * 
     * @throws Exception the exception
     */
    private List searchMetaThesaurusConcepts(MetaThesaurusConcept mtc) throws Exception{
        Field[] fields = mtc.getClass().getDeclaredFields();
        String cui = null;
        String name = null;
        String srcAbbreviation = null;
        Atom atom = null;
        EVSQuery evsQuery = new EVSQueryImpl();
        for(Field f: fields){
            f.setAccessible(true);
            if(f.getName().equalsIgnoreCase("serialVersionUID")){
                continue;
            }
            if(f.get(mtc)!=null){
                if(f.getName().endsWith("Collection")){
                    Collection c = (Collection)f.get(mtc);
                    if(c.size()<=0){
                        continue;
                    }
                }
                if(f.getName().equalsIgnoreCase("cui")){
                    cui = (String)f.get(mtc);
                }else  if(f.getName().equalsIgnoreCase("name")){
                    name = (String)f.get(mtc);
                }else if(f.getName().equalsIgnoreCase("sourceCollection")){
                    ArrayList sList = (ArrayList)f.get(mtc);
                    if(sList.size()>0){
                        Source s = (Source)sList.get(0);
                        if(s.getAbbreviation()!=null){
                            srcAbbreviation = s.getAbbreviation();
                        }
                    }
                }else if(f.getName().equalsIgnoreCase("atomCollection")){
                    ArrayList aList = (ArrayList)f.get(mtc);
                    if(aList.size()>0){
                        atom = (Atom)aList.get(0);
                    }
                }
            }
        }
        if(cui == null && name == null){
            if(atom.getCode()!=null){
                cui = atom.getCode();
            }else if(atom.getName() != null){
                name = atom.getName();
            }
        }


        if(cui != null && srcAbbreviation == null){
			//KLO GF7862 08/30/07
			evsQuery.searchMetaThesaurus(cui, limit, srcAbbreviation, true, false, false);
            //evsQuery.searchMetaThesaurus(cui);
        } else if(cui != null && srcAbbreviation != null){
            evsQuery.searchMetaThesaurus(cui, limit, srcAbbreviation, true, false, false);
        } else if(name !=null){
            evsQuery.searchMetaThesaurus(name, limit, srcAbbreviation, false, false, false);
        } else{
            throw new Exception("Invalid search criteria - specify concept cui or name");
        }
        return query(evsQuery);

    }
 //================================
    /**
  * Returns all Property names from the NCI_Thesaurus.
  * 
  * @return the all properties
  * 
  * @throws Exception the exception
  */
    private List getAllProperties()throws Exception{
        EVSQuery evsQuery = new EVSQueryImpl();
        evsQuery.getAllPropertyTypes(defaultVocabulary);
        List results = query(evsQuery);
        List propList = new ArrayList();
        for(int i=0; i< results.size(); i++){
            Property prop = new Property();
            prop.setName((String)results.get(i));
            propList.add(prop);
        }
        return propList;
    }

    /**
     * Returns all Qualifier names from the NCI_Thesaurus.
     * 
     * @return the all qualifiers
     * 
     * @throws Exception the exception
     */
    private List getAllQualifiers() throws Exception{
        EVSQuery evsQuery = new EVSQueryImpl();
        evsQuery.getAllQualifierTypes(defaultVocabulary);
        List results = query(evsQuery);
        List qList = new ArrayList();
        for(int i=0; i< results.size(); i++){
            Qualifier q = new Qualifier();
            q.setName((String)results.get(i));
            qList.add(q);
        }
        return qList;
    }

    /**
     * Returns all the Role names from the NCI_Thesaurus.
     * 
     * @return the all roles
     * 
     * @throws Exception the exception
     */
    private List getAllRoles()throws Exception{
        EVSQuery evsQuery = new EVSQueryImpl();
        evsQuery.getAllRoleNames(defaultVocabulary);
        List results = query(evsQuery);
        List roleList = new ArrayList();
        for(int i=0; i< results.size(); i++){
            Role role = new Role();
            role.setName((String)results.get(i));
            roleList.add(role);
        }
        return roleList;
    }

    /**
     * Returns all Association names from the NCI_Thesaurus.
     * 
     * @return the all associations
     * 
     * @throws Exception the exception
     */
    private List getAllAssociations() throws Exception{
        EVSQuery evsQuery = new EVSQueryImpl();
        evsQuery.getAllAssociationTypes(defaultVocabulary);
        List results = query(evsQuery);
        List assList = new ArrayList();
        for(int i=0; i< results.size(); i++){
            Association ass = new Association();
            ass.setName((String)results.get(i));
            assList.add(ass);
        }
        return assList;
    }
    
    /**
     * Returns all SemanticTypes from the Metaphrase.
     * 
     * @return the all semantic types
     * 
     * @throws Exception the exception
     */
    private List getAllSemanticTypes() throws Exception{
        EVSQuery evsQuery = new EVSQueryImpl();
        evsQuery.getSemanticTypes();
        return query(evsQuery);
    }
    
    /**
     * Returns a list of Atoms for one or more MetaThesaurusConcepts specified in the list.
     * 
     * @param mtcList List of instance of gov.nih.nci.evs.domain.MetaThesaurusConcepts
     * 
     * @return the atoms
     * 
     * @throws Exception the exception
     */
    private List getAtoms(List mtcList)throws Exception{
        Set list = new HashSet();

        for(int i=0; i<mtcList.size(); i++){
            MetaThesaurusConcept mtc = (MetaThesaurusConcept)mtcList.get(i);
            List atomList = mtc.getAtomCollection();
            for(int a=0; a< atomList.size(); a++){
                list.add(atomList.get(a));
            }
        }
        List atoms = new ArrayList();
        atoms.addAll(list);
        return atoms;
    }
    
    /**
     * Returns a list of HistoryRecords for a given EVS criteria.
     * 
     * @param criteria - instance of gov.nih.nci.evs.domain.* object
     * 
     * @return the history record
     * 
     * @throws Exception the exception
     */
  private List getHistoryRecord(Object criteria)throws Exception{
      EVSQuery evsQuery = new EVSQueryImpl();
      List result = null;
      String conceptCode = null;
      Date date = null;
      if(criteria.getClass().getName().endsWith("DescLogicConcept")){
              DescLogicConcept dlc = (DescLogicConcept)criteria;
              conceptCode = dlc.getCode();
      }
      else if(criteria.getClass().getName().endsWith("History")){
          History history = (History)criteria;
          if(history.getReferenceCode()!= null){
              conceptCode = history.getReferenceCode();
              if(history.getEditActionDate() != null){
                  date = history.getEditActionDate();
              }
          }
      }
      else if(criteria.getClass().getName().endsWith("HistoryRecord")){
          HistoryRecord history = (HistoryRecord)criteria;
          if(history.getDescLogicConceptCode()!= null){
              conceptCode = history.getDescLogicConceptCode();
          }
      }
      if(conceptCode != null){
          if(date != null){
              evsQuery.getHistoryRecords(defaultVocabulary, String.valueOf(date), String.valueOf(date), conceptCode);
          }else{
              evsQuery.getHistoryRecords(defaultVocabulary, conceptCode);
          }
         result = query(evsQuery);
      }else{
          throw new Exception("Concept code not specified - Please enter a valid concept code");
      }
      return result;
  }
  
  /**
   * Gets HistoryRecords for one or more DescLogicConepts specified in the list.
   * 
   * @param concepts the concepts
   * 
   * @return the history records
   * 
   * @throws Exception the exception
   */
  private List getHistoryRecords(List concepts) throws Exception {
      List results = new ArrayList();
      for (int i = 0; i < concepts.size(); i++) {
              List result = getHistoryRecord(concepts.get(i));
              if(result != null && result.size()>0){
                  results.add(result.get(0));
              }
        }
      return results;
  }
  
  /**
   * Returns the specified Source from Metaphrase.
   * 
   * @param abbreviation the abbreviation
   * 
   * @return the meta source
   * 
   * @throws Exception the exception
   */
  private List getMetaSource(String abbreviation)throws Exception{
      List sourceList = getAllMetaSources();
      List result = new ArrayList();
      for(int i=0; i < sourceList.size(); i++){
          Source src = (Source)sourceList.get(i);
          if(src.getAbbreviation().equalsIgnoreCase(abbreviation)){
              result.add(src);
              break;
          }
      }
      return result;
  }
  
  /**
   * Returns all Sources from the Metaphrase.
   * 
   * @return the all meta sources
   * 
   * @throws Exception the exception
   */
  private List getAllMetaSources() throws Exception{
      EVSQuery evsQuery = new EVSQueryImpl();
      evsQuery.getMetaSources();
      return query(evsQuery);
  }
  
  /**
   * Returns a list of Sources for one or more MetaThesaurusConcepts specified in the list.
   * 
   * @param mtcList List of instance of gov.nih.nci.evs.domain.MetaThesaurusConcepts
   * 
   * @return the meta sources
   * 
   * @throws Exception the exception
   */
  private List getMetaSources(List mtcList) throws Exception{
      Set list = new HashSet();

      for(int i=0; i<mtcList.size(); i++){
          MetaThesaurusConcept mtc = (MetaThesaurusConcept)mtcList.get(i);
          List sourceList = mtc.getSourceCollection();
          for(int a=0; a< sourceList.size(); a++){
              list.add(sourceList.get(a));
          }
      }
      List sources = new ArrayList();
      sources.addAll(list);
      return sources;
  }
  
  /**
   * Returns a list of Description Logic vocabularies.
   * 
   * @return the all vocabularies
   * 
   * @throws Exception the exception
   */

  private List getAllVocabularies() throws Exception{
    EVSQuery evsQuery = new EVSQueryImpl();
    evsQuery.getAllVocabularies();
    return query(evsQuery);
  }
    
    /**
     * Returns a list of evs domain objects beased on a given search criteria.
     * 
     * @param parameterList - Return class name with an optional parameter that specifies a vocabularyName (String)
     * @param startIndex - Starting record number of the result set
     * @param recordCounter - Total number of records to be returned
     * @param criteria the criteria
     * 
     * @return the list
     * 
     * @throws Exception the exception
     */
    public List evsSearch(String parameterList, Object criteria,
        int startIndex, int recordCounter) throws Exception {
        Object searchObject = criteria;
        String searchClass = null;
        int total = 0;
        if (startIndex > 0) {
            total = startIndex;
        }
        if (recordCounter > 0 && recordCounter != 1000) {
            total += recordCounter;
        } else {
            total += limit;
        }
        limit = Integer.valueOf(total);

        if (parameterList.indexOf(",") > 0) {
            String[] params = parameterList.split(",");
            if(params.length == 3){
                searchClass = params[0];
                defaultVocabulary = params[1];
                limit = Integer.valueOf(params[3]).intValue();
            }else if(params.length == 2){
                searchClass = params[0];
                defaultVocabulary = params[1];
            }
        }
        List evsResults = new ArrayList();
      try{
          evsResults = getEVSResults(searchClass, searchObject);
      }catch(Exception ex){
          log.error(ex.getMessage());
          throw new Exception(ex.getMessage());
      }


      return evsResults;
    }

//================================


    /**
 * Gets the eVS results.
 * 
 * @param searchClassName the search class name
 * @param criteria the criteria
 * 
 * @return the eVS results
 * 
 * @throws Exception the exception
 */
private List getEVSResults(String searchClassName, Object criteria) throws Exception{
        List results = queryObject(criteria);
        List filteredList = new ArrayList();


        if (searchClassName.endsWith("Vocabulary")){
			List resultList = new ArrayList();
        	for(Object searchResult: results){
				if (criteria.getClass().getName().endsWith("DescLogicConcept"))
				{
					Vocabulary v = ((DescLogicConcept)searchResult).getVocabulary();
					resultList.add(v);
					return resultList;
			    }
			}
		}

        if (searchClassName.endsWith("Source")){
			List resultList = new ArrayList();
        	for(Object searchResult: results){
				if (criteria.getClass().getName().endsWith("Atom"))
				{
					Source src = ((Atom)searchResult).getSource();
					resultList.add(src);
					return resultList;
			    }
			}
		}


        for(Object searchResult: results){
            if(!searchClassName.equalsIgnoreCase(criteria.getClass().getName())){
                //search class is different from criteria class
                //Check if objects are related

                String className = searchClassName;


                if(className.indexOf(".")>0){
                    className = className.substring(className.lastIndexOf(".")+1);
                }
                if(isAssociation(className, searchResult.getClass())){
                    Method method = getAssociatedMethod(className, searchResult.getClass());
                    if(method == null){
                        throw new Exception("Unable to find associations");
                    }
//                    List resultList = new ArrayList();
                    String methodName = null;
//                    Object[] args = new Object[2];

                    if(method.isAnnotationPresent(gov.nih.nci.evs.annotation.LazyLoad.class) ){
                        EVSQuery query = new EVSQueryImpl();
                        Method[] queryMethods = query.getClass().getDeclaredMethods();
                        if(criteria.getClass().getName().endsWith("DescLogicConcept")){
                            methodName= method.getName()+"byCode";

                            String code  = ((DescLogicConcept)searchResult).getCode();
                            Vocabulary v = ((DescLogicConcept)searchResult).getVocabulary();
                            String vocabName = v.getName();

                            for(Method m: queryMethods){
                                if(methodName.equalsIgnoreCase(m.getName())){
                                    m.invoke(query, new Object[]{vocabName, code});
                                    filteredList.addAll(query(query));
                                }
                            }
                        }else if(criteria.getClass().getName().endsWith("MetaThesaurusConcept")){
                            methodName= method.getName()+"byCui";
                            String cui = ((MetaThesaurusConcept)searchResult).getCui();
                            for(Method m: queryMethods){
                                if(methodName.equalsIgnoreCase(m.getName())){
                                    m.invoke(query, new Object[]{cui});
                                    filteredList.addAll(query(query));
                                }
                            }
                        }

                    } else{
                        if(method.invoke(searchResult, new Object[] {null}) != null){
                            Object value = method.invoke(searchResult, new Object[] {null});
                            if(method.getReturnType().getName().equalsIgnoreCase("java.util.Vector")){
                               Vector v = (Vector)value;
                                for(Object o: v){
                                    filteredList.add(o);
                                }
                            }else if(value instanceof java.util.Collection){
                               filteredList.addAll((List)value);

                            }else{
                                 filteredList.add(value);
                            }
                        }
                    }
                    }else{
                    throw new Exception("No associations found between "+ searchClassName +"\t"+ criteria.getClass().getName());
                }
            }else{
                return results;
            }

        }

        return filteredList;
    }

    /**
     * Gets the associated method.
     * 
     * @param searchClassName the search class name
     * @param criteria the criteria
     * 
     * @return the associated method
     */
    private  Method getAssociatedMethod(String searchClassName, Class criteria){
        Method method = null;
        Method[] methods = criteria.getDeclaredMethods();
        for(Method m: methods){
            String bean = null;
            String mName = m.getName();
            if(mName.toLowerCase().indexOf(searchClassName.toLowerCase())<0){
                continue;
            }else if(mName.startsWith("get")){
                bean = mName.substring("get".length());
                if(mName.endsWith("Collection")){
                    bean = bean.substring(0, bean.indexOf("Collection"));
                }
                if(searchClassName.equalsIgnoreCase(bean)){
                    method = m;
                    break;
                }
            }else{
                continue;
            }

        }
        return method;
    }
    
    /**
     * Checks if is association.
     * 
     * @param searchClassName the search class name
     * @param criteria the criteria
     * 
     * @return true, if is association
     */
    private boolean isAssociation(String searchClassName, Class criteria){
        boolean found = false;
        Field[] fields = criteria.getDeclaredFields();
        for(Field f: fields){
            f.setAccessible(true);
            String fieldName = f.getName();
            String association = fieldName;
            if(fieldName.endsWith("Collection")){
                association = fieldName.substring(0, fieldName.indexOf("Collection"));
            }
            if(association.startsWith("inverse")){
                association = association.substring("inverse".length());
            }
            if(searchClassName.equalsIgnoreCase(association)){
                found = true;
                break;
            }
        }
        return found;
    }

    /**
     * Query object.
     * 
     * @param criteria the criteria
     * 
     * @return the list
     * 
     * @throws Exception the exception
     */
    private List queryObject(Object criteria) throws Exception{
        List results = new ArrayList();
        if(criteria.getClass().getName().equalsIgnoreCase("gov.nih.nci.evs.domain.DescLogicConcept")){
            DescLogicConcept dlc = (DescLogicConcept)criteria;
            //return searchDescLogic(dlc);
            return searchDescLogicConcepts(dlc);
        }
        if(criteria.getClass().getName().equalsIgnoreCase("gov.nih.nci.evs.domain.MetaThesaurusConcept")){
            MetaThesaurusConcept mtc = (MetaThesaurusConcept)criteria;
            return searchMetaThesaurusConcepts(mtc);
        }
        if(criteria.getClass().getName().equalsIgnoreCase("gov.nih.nci.evs.domain.Property")){
            Property p = (Property)criteria;
            List pList = this.getAllProperties();
            if(p.getName()!=null){
                for(Object o : pList){
                    Property property = (Property)o;
                    //GF9122
                    //if(property.getName().equalsIgnoreCase(p.getName())){
					if(match(property.getName(), p.getName())){
                        results.add(property);
                        //break;
                    }
                }
            }else{
                return pList;
            }
        }
        if(criteria.getClass().getName().equalsIgnoreCase("gov.nih.nci.evs.domain.Role")){
            Role r = (Role)criteria;
            List rList = this.getAllRoles();
            if(r.getName()!=null){
                for(Object o : rList){
                    Role role = (Role)o;
                    //GF9122
                    //if(role.getName().equalsIgnoreCase(r.getName())){
					if(match(role.getName(), r.getName())){
                        results.add(role);
                        //break;
                    }
                }
            }else{
                return rList;
            }
        }
        if(criteria.getClass().getName().equalsIgnoreCase("gov.nih.nci.evs.domain.Association")){
            Association a = (Association)criteria;
            List aList = this.getAllAssociations();
            if(a.getName()!=null){
                for(Object o : aList){
                    Association asso = (Association)o;
                    //GF9122
                    //if(asso.getName().equalsIgnoreCase(a.getName())){
					if(match(asso.getName(), a.getName())){
                        results.add(asso);
                        //break;
                    }
                }
            }else{
                return aList;
            }
        }
        if(criteria.getClass().getName().equalsIgnoreCase("gov.nih.nci.evs.domain.Qualifier")){
            Qualifier q = (Qualifier)criteria;
			//KLO GF7862 08/30/07
            List qList = this.getAllQualifiers();
            if(q.getName()!=null){
                for(Object o : qList){
                    Qualifier qo = (Qualifier)o;
                    //GF9122
                    //if(qo.getName().equalsIgnoreCase(q.getName())){
					if(match(qo.getName(), q.getName())){
                        results.add(qo);
                        //break;
                    }
                }
            }else{
                return qList;
            }
        }
        if(criteria.getClass().getName().equalsIgnoreCase("gov.nih.nci.evs.domain.Vocabulary")){
            Vocabulary v = (Vocabulary)criteria;
            List vList = this.getAllVocabularies();
            if(v.getName()!=null){
                for(Object o : vList){
                    Vocabulary vo = (Vocabulary)o;
                    //GF9122
                    //if(vo.getName().equalsIgnoreCase(v.getName())){
					if(match(vo.getName(), v.getName())){
                        results.add(vo);
                        //break;
                    }
                }
            }else{
                return vList;
            }
        }
        if(criteria.getClass().getName().equalsIgnoreCase("gov.nih.nci.evs.domain.Source")){
            Source s = (Source)criteria;
            List sList = this.getAllMetaSources();
            if(s.getAbbreviation()!=null){
                for(Object o : sList){
                    Source so = (Source)o;
                    //GF9122
                    //if(so.getAbbreviation().equalsIgnoreCase(s.getAbbreviation())){
					if(match(so.getAbbreviation(), s.getAbbreviation())){
                        results.add(so);
                        //break;
                    }
                }
            }else{
                return sList;
            }
        }

        if(criteria.getClass().getName().equalsIgnoreCase("gov.nih.nci.evs.domain.Atom")){
            Atom a = (Atom) criteria;
            String atomName = a.getName();
            String atomCode = a.getCode();
            String atomOrigin = a.getOrigin();
			EVSQuery evsQuery = new EVSQueryImpl();
			if (atomName != null)
			{
	        	evsQuery.searchMetaThesaurus(atomName, 100, atomOrigin,
									false, false, false);
			}
			else if (atomCode != null)
			{
	        	evsQuery.searchMetaThesaurus(atomCode, 100, atomOrigin,
									false, false, false);
			}

			List concepts = query(evsQuery);
			if (concepts != null)
			{
				for (int k=0; k<concepts.size(); k++)
				{
					MetaThesaurusConcept mtc = (MetaThesaurusConcept) concepts.get(k);
				    evsQuery = new EVSQueryImpl();
					evsQuery.getAtomCollectionbyCui(mtc.getCui());
					List atomList = query(evsQuery);
					for (int j = 0; j < atomList.size(); j++) {
						Atom atom = (Atom) atomList.get(j);
						if (atomCode != null && atom.getCode().compareTo(atomCode) == 0)
						{
							if (atomOrigin != null)
							    if (atomOrigin.compareTo(atom.getOrigin()) == 0)
							         results.add(atom);
							else
							    results.add(atom);
						}
						else if (atomName != null && atom.getName().compareTo(atomName) == 0)
						{
							if (atomOrigin != null)
							    if (atomOrigin.compareTo(atom.getOrigin()) == 0)
							         results.add(atom);
							else
							    results.add(atom);						}
					}
	     		}
			}

			else
			{
				return new ArrayList();
			}
        }


        if(criteria.getClass().getName().equalsIgnoreCase("gov.nih.nci.evs.domain.SemanticType")){
            SemanticType s = (SemanticType)criteria;
            List sList = this.getAllSemanticTypes();
            if(s.getId()!=null || s.getName()!=null){
                for(Object o : sList){
                    SemanticType so = (SemanticType)o;
                    //GF9122
                    //if(so.getId().equalsIgnoreCase(s.getId())|| so.getName().equalsIgnoreCase(s.getName())){
					if(contains(so.getId(), s.getId()) || contains(so.getName(), s.getName())){
                        results.add(so);
                        //break;
                    }
                }
            }else{
                return sList;
            }
        }
        if(criteria.getClass().getName().equalsIgnoreCase("gov.nih.nci.evs.domain.History")){
            return this.getHistoryRecord(criteria);
        }
        if(criteria.getClass().getName().equalsIgnoreCase("gov.nih.nci.evs.domain.HistoryRecord")){
            return this.getHistoryRecord(criteria);
        }
        return results;
    }


    //GF9122
    /**
     * Match.
     * 
     * @param s the string
     * @param target the target
     * 
     * @return true, if successful
     */
    public boolean match(String s, String target)
    {
		if (s == null || s.length() == 0) return false;
		if (target == null || target.length() == 0) return false;
		String wildcard = "*";
		if (target.indexOf(wildcard) == -1)
		{
			return contains(s, target);
		}

		if (target.indexOf(wildcard) == 0 && target.lastIndexOf(wildcard) == target.length()-1)
		{
			return contains(s, target);
		}

		if (target.indexOf(wildcard) != 0 && target.lastIndexOf(wildcard) == target.length()-1)
		{
			return startsWith(s, target);
		}


		if (target.indexOf(wildcard) == 0 && target.lastIndexOf(wildcard) != target.length()-1)
		{
			return endsWith(s, target);
		}
		return false;
	}


    //GF9122
    /**
     * Contains.
     * 
     * @param s the string
     * @param target the target
     * 
     * @return true, if successful
     */
    public boolean contains(String s, String target)
    {
		if (s == null || s.length() == 0) return false;
		if (target == null || target.length() == 0) return false;
		String wildcard = "*";
		if (target.equals(wildcard)) return true;
		if (target.indexOf(wildcard) == 0 && target.lastIndexOf(wildcard) == target.length()-1)
		{
			target = target.substring(1, target.length());
			target = target.substring(0, target.length()-1);
		}
		s = s.toLowerCase();
		target = target.toLowerCase();
		if (s.indexOf(target) != -1) return true;
		return false;

	}

    //GF9122
    /**
     * Starts with.
     * 
     * @param s the string
     * @param target the target
     * 
     * @return true, if successful
     */
    public boolean startsWith(String s, String target)
    {
		if (s == null || s.length() == 0) return false;
		if (target == null || target.length() == 0) return false;
		String wildcard = "*";
		if (target.equals(wildcard)) return true;
		if (target.lastIndexOf(wildcard) == target.length()-1)
		{
			target = target.substring(0, target.length()-1);
		}
		s = s.substring(0, target.length());
		s = s.toLowerCase();
		target = target.toLowerCase();
		if (s.equals(target)) return true;
		return false;

	}

    //GF9122
    /**
     * Ends with.
     * 
     * @param s the string
     * @param target the target
     * 
     * @return true, if successful
     */
    public boolean endsWith(String s, String target)
    {
		if (s == null || s.length() == 0) return false;
		if (target == null || target.length() == 0) return false;
		String wildcard = "*";
		if (target.equals(wildcard))
		{
			return true;
		}
		if (target.indexOf(wildcard) == 0)
		{
			target = target.substring(1, target.length());
		}
		if (s.length()<target.length()) return false;
        s = s.substring(s.length()-target.length(), s.length());
		s = s.toLowerCase();
		target = target.toLowerCase();
		if (s.equals(target)) return true;
		return false;

	}

}
