package gov.nih.nci.system.dao.security;

/**
 * @author Shaziya Muhsin *
 */

public class SecurityKey {
	private Object key;
	private UserCredentials credentials;
	
	/**
	 * Instantiates a new SecurityKey.
	 */
	public SecurityKey(){
		key = new Object();
		credentials = new UserCredentials();
	}	
	
	/**
	 * Instantiates a new SecurityKey.
	 * 
	 * @param key the key
	 * @param credentials the credentials
	 */
	public SecurityKey(Object key, UserCredentials credentials){
		setSecurityKey(key);
		setCredentials(credentials);
	}
	
	/**
	 * Sets the credentials.
	 * 
	 * @param credentials the new credentials
	 */
	public void setCredentials(UserCredentials credentials){
		this.credentials = credentials;
	}
	
	/**
	 * Sets the security key.
	 * 
	 * @param key the new security key
	 */
	public void setSecurityKey(Object key){
		this.key = key;
	}
	
	/**
	 * Gets the security key.
	 * 
	 * @return the security key
	 */
	public Object getSecurityKey(){
		return this.key;
	}
	
	/**
	 * Gets the credentials.
	 * 
	 * @return the credentials
	 */
	public UserCredentials getCredentials(){
		return this.credentials;
	}
	


}
