package gov.nih.nci.evs;

import gov.nih.nci.evs.history.HistoryTest;
import gov.nih.nci.evs.metadata.MetadataTest;
import gov.nih.nci.evs.query.DLQuery;
import gov.nih.nci.evs.query.MetathesaurusQuery;
import gov.nih.nci.evs.query.WebServiceTest;
import gov.nih.nci.evs.tree.MetathesaurusTree;
import gov.nih.nci.evs.tree.TreeTest;
import gov.nih.nci.evs.tree.CaDSR_TreeTest;
import gov.nih.nci.evs.domain.DomainTestSuite;
import gov.nih.nci.evs.domain.QBE_DescLogicConcept;
import gov.nih.nci.evs.domain.QBE_Metathesaurus;
import junit.framework.Test;
import junit.framework.TestSuite;

/**
 * The Class AllTests_EVSQuery.
 */
public class AllTests_EVSQuery {
    
    /**
     * Suite.
     * 
     * @return the test
     * 
     * @throws Exception the exception
     */
    public static Test suite() throws Exception
    {
        TestSuite mainSuite = new TestSuite("EVSAPI validation tests");
        EVSQueryServiceHolder.configure();
        EVSQueryServiceTestCase.initialize();
        
        
        mainSuite.addTestSuite(TestAllVocabs.class);
        mainSuite.addTestSuite(QBE_DescLogicConcept.class);
        mainSuite.addTestSuite(HistoryTest.class);
        mainSuite.addTestSuite(MetadataTest.class);
        mainSuite.addTestSuite(DLQuery.class);
        mainSuite.addTestSuite(MetathesaurusQuery.class);
        mainSuite.addTestSuite(WebServiceTest.class);
        mainSuite.addTestSuite(MetathesaurusTree.class);
        mainSuite.addTestSuite(TreeTest.class);
        mainSuite.addTest(DomainTestSuite.suite());
        mainSuite.addTestSuite(CaDSR_TreeTest.class);
        return mainSuite;
    }
}
