package gov.nih.nci.evs;

import gov.nih.nci.ServiceTestCase;
import gov.nih.nci.system.applicationservice.EVSApplicationService;
import gov.nih.nci.system.client.ApplicationServiceProvider;


/**
 * The Class EVSQueryServiceHolder.
 */
public class EVSQueryServiceHolder {
    private static EVSQueryServiceHolder sh_;
    private EVSApplicationService  appService = null;
	private static final String serviceUrl = ServiceTestCase.serviceUrl;
	private static final String _service = "EvsServiceInfo";
	
    /**
     * Use this to get an instance of the ServiceHolder. If 'configureForSingleConfig' has not been called,
     * this will run the tests on all configured databases in the testConfig.props file.
     * 
     * @return the EVS query service holder
     */
    public static EVSQueryServiceHolder instance()
    {
        if (sh_ == null)
        {
            throw new RuntimeException("ServiceHolder has not been configured");
            //sh_ = new ServiceHolder(true, false);
        }
        return sh_;

    }
    
//	/**
//	 * Use this to set up the tests for end user enviroment validation. Only runs the tests once, using their
//	 * normal config file.
//	 * 
//	 * @param useCaCore the use ca core
//	 */
//	public static void configure(boolean useCaCore)
//	{
//
//		sh_ = new EVSQueryServiceHolder(useCaCore);
//
//	}

	/**
	 * Use this to set up the tests for end user enviroment validation. Only runs the tests once, using their
	 * normal config file.
	 * 
	 */
	public static void configure()
	{

		sh_ = new EVSQueryServiceHolder();

	}
	
//	/**
//	 * Instantiates a new eVS query service holder.
//	 * 
//	 * @param useCaCore the use ca core
//	 */
//	private EVSQueryServiceHolder(boolean useCaCore)
//	{
//		try{
//			appService =  (EVSApplicationService)ApplicationServiceProvider.getApplicationServiceFromUrl(serviceUrl);
//		}
//		catch (Exception e)
//		{
//			System.err.println("Problem initiating Test config");
//			e.printStackTrace();
//			System.exit(-1);
//		}
//	}
	
	/**
	 * Instantiates a new eVS query service holder.
	 * 
	 */
	private EVSQueryServiceHolder()
	{
		try{
			appService =  (EVSApplicationService)ApplicationServiceProvider.getApplicationServiceFromUrl(serviceUrl, _service);
		}
		catch (Exception e)
		{
			System.err.println("Problem initiating Test config");
			e.printStackTrace();
			System.exit(-1);
		}
	}
	
	/**
	 * Gets the uRL.
	 * 
	 * @return the uRL
	 */
	public static String getURL()
	{
		return serviceUrl;
	}
	
	/**
	 * Gets the app service.
	 * 
	 * @return an instance of the app service
	 */
	public EVSApplicationService getAppService()
	{
		return appService;
	}

}
