package gov.nih.nci.evs;

import gov.nih.nci.ServiceTestCase;
import gov.nih.nci.SchemaInfo;
import gov.nih.nci.evs.domain.DescLogicConcept;
import gov.nih.nci.evs.domain.MetaThesaurusConcept;
import gov.nih.nci.evs.query.EVSQuery;
import gov.nih.nci.evs.query.EVSQueryImpl;

//import java.util.List;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Vector;

/**
 * The Class EVSQueryServiceTestCase.
 */
abstract public class EVSQueryServiceTestCase extends ServiceTestCase{


	abstract protected String getTestID();
	private static DescLogicConcept dlc = null;
	private static DescLogicConcept dlc_ir = null;
	private static DescLogicConcept dlc_ia = null;
	private static MetaThesaurusConcept mtc = null;
    
    public Vector<SchemaInfo> getTestList()
    {
    	return testList;
    }
    
    public static void initialize(){
    	String vocabName = ServiceTestCase.THES_SCHEME;
    	String conceptCode = DOMAIN_CONCEPT_CODE; //Character
    	
//    	String metaName = ServiceTestCase.META_SCHEME;
    	String cui = DOMAIN_CUI; //Character
    	try{
//    		EVSQuery evsQuery = new EVSQueryImpl();
//    		evsQuery.getDescLogicConcept(vocabName, conceptCode);
//    		List evsResults=new ArrayList();
//    		evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
//    	    dlc = (DescLogicConcept)evsResults.get(0);
    	    DescLogicConcept input_dlc = new DescLogicConcept();
    	    input_dlc.setCode(conceptCode);
			List<Object> results = EVSQueryServiceHolder.instance().getAppService().search("gov.nih.nci.evs.domain.DescLogicConcept", input_dlc);
			for (int i = 0; i<results.size();i++)
    	    {
    	    	dlc = (DescLogicConcept)results.get(i);
    	    }
			
			for (Object o : results){
    	    	dlc = (DescLogicConcept)o;
    	    }
    	    
			input_dlc.setCode(DOMAIN_CONCEPT_CODE_INVERSE_ROLE);
			results = EVSQueryServiceHolder.instance().getAppService().search("gov.nih.nci.evs.domain.DescLogicConcept", input_dlc);
			for (int i = 0; i<results.size();i++)
    	    {
    	    	dlc_ir = (DescLogicConcept)results.get(i);
    	    }
			
			for (Object o : results){
    	    	dlc_ir = (DescLogicConcept)o;
    	    }
			
			input_dlc.setCode(DOMAIN_CONCEPT_CODE_INVERSE_ASSOC);
			results = EVSQueryServiceHolder.instance().getAppService().search("gov.nih.nci.evs.domain.DescLogicConcept", input_dlc);
			for (int i = 0; i<results.size();i++)
    	    {
    	    	dlc_ia = (DescLogicConcept)results.get(i);
    	    }
			
			for (Object o : results){
    	    	dlc_ia = (DescLogicConcept)o;
    	    }
			
    	    MetaThesaurusConcept input_mtc = new MetaThesaurusConcept();
    	    input_mtc.setCui(cui);
			results = EVSQueryServiceHolder.instance().getAppService().search("gov.nih.nci.evs.domain.MetaThesaurusConcept", input_mtc);
    	    for (Object o : results){
    	    	mtc = (MetaThesaurusConcept)o;
    	    }
			
    	}
    	catch (Exception e){
    		e.printStackTrace();
    	}
    }
    
    public static DescLogicConcept getDescLogicConcept(){
    	return EVSQueryServiceTestCase.dlc;
    }
    
    public static DescLogicConcept getDescLogicConcept_inverse_role(){
    	return EVSQueryServiceTestCase.dlc_ir;
    }
    
    public static DescLogicConcept getDescLogicConcept_inverse_association(){
    	return EVSQueryServiceTestCase.dlc_ia;
    }
    
    public static MetaThesaurusConcept getMetaThesaurusConcept(){
    	return EVSQueryServiceTestCase.mtc;
    }
}
