//This test based on a script provided by Larry Hebel

package gov.nih.nci.evs;

import gov.nih.nci.evs.query.EVSQuery;
import gov.nih.nci.evs.query.EVSQueryImpl;

import gov.nih.nci.SchemaInfo;

import java.util.ArrayList;
import java.util.List;

/**
 * The Class TestAllVocabs.
 */
public class TestAllVocabs extends EVSQueryServiceTestCase{

    final static String testID = "TestAllVocabs";

    @Override
    protected String getTestID()
    {
        return testID;
    }

    //do the evs vocabulary search
    /**
     * loops through the vocabularies stored in the vector
     * calls the api with the search term and prop type as per the vocabulary.
     * 
     * @throws Exception the exception
     */
    public void  testEVSSearch() throws Exception
    {
    	

      //loop through vocabs to do the search
      if (getTestList() == null || testList.size() < 0)
        fail("unable to get test list");
      else
      {
        for (int i=0; i<testList.size(); i++)
        {
          //get the variable from the vector to search
          SchemaInfo info = (SchemaInfo)testList.elementAt(i);
          String vocabName = (String)info.getCodingScheme();
            String conName = (String)info.getSearchTerm();
          //get the search type
          String serType = "Name";
            serType = (String)info.getPropertyToSearch();
          
          try
          {
            //define this query by defualt do this for test 
            EVSQuery evsQuery =  new EVSQueryImpl();

              if (serType.equals("Name"))
                evsQuery.searchDescLogicConcepts(vocabName,conName,100);
              else
                evsQuery.searchDescLogicConcepts(vocabName,conName,100,2,serType,1);
           
            //get the results
            getConceptResults(evsQuery, i);
          }
          catch(Exception e)
          {
            System.out.println("Error Occured in doEVSSearch - querydefine : " + e.toString());
          }
        }        
      }  
    }

    /** 
     * to get concept results from the application service
     * Object returned in the results list depends on the type of query
     * Most of them have DiscLogicConcept object where some queries return source and property objects.
     * commented lines are kept to use for other types of queries.
     * 
     * @param evsQuery EVSQuery object
     */
    private static void getConceptResults(EVSQuery evsQuery, int set)
    {
      List evsResults = new ArrayList();
      try
      {
        //returns list of objects from the search
        evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
        assertNotNull("Not Null " + (String)testList.elementAt(set).toString(),evsResults);
        assertTrue("Has values " +(String)testList.elementAt(set).toString(),evsResults.size()>0);

      }
      catch(Exception e)
      {
        System.out.println("Error Occured in getConceptResults : " + e.toString());
      }
    }
    
}
