package gov.nih.nci.evs.domain;

import static org.junit.Assert.*;

import java.util.ArrayList;

import gov.nih.nci.evs.EVSQueryServiceTestCase;

import org.junit.Test;

public class AtomTests extends EVSQueryServiceTestCase{
    
	final static String testID = "domain_AtomTest";
	ArrayList<Atom> Atoms = EVSQueryServiceTestCase.getMetaThesaurusConcept().getAtomCollection();
	Atom setAtom = new Atom();
    @Override
    protected String getTestID()
    {
        return testID;
    }

	@Test
	public final void testGetCode() {
		assertNotNull("Atoms should be returned", Atoms);
		assertTrue("Atoms list should have values", Atoms.size()>0);
		boolean found = false;
		Atom atom = new Atom();
		for (int i=0;i<Atoms.size();i++)
		{
			atom = (Atom)Atoms.get(i);
			String name = atom.getCode();
			if (name.equals(DOMAIN_ATOMCODE)) found = true;
		}
		assertTrue("Atom Code found in list", found);
	}

	@Test
	public final void testSetCode() {
		String setCode="OA1234";
		setAtom.setCode(setCode);
		String code = "";
		code = setAtom.getCode();
		assertTrue("Code set",code.equals(setCode));
	}

	@Test
	//TODO Find an Atom with LUI
	public final void testGetLui() {
		boolean found = false;
		Atom atom = new Atom();
		for (int i=0;i<Atoms.size();i++)
		{
			atom = (Atom)Atoms.get(i);
			assertNotNull("atom is not null",atom);
			String name = atom.getLui();
			assertNotNull("Atom has lui", name);
			if (name.equals(DOMAIN_LUI)) found = true;
		}
		assertFalse("Atom Code not found in list", found);
	}

	@Test
	public final void testSetLui() {
		String setLui="OA1234";
		setAtom.setLui(setLui);
		String lui = "";
		lui = setAtom.getLui();
		assertTrue("Code set",lui.equals(setLui));
	}

	@Test
	public final void testGetName() {
		boolean found = false;
		Atom atom = new Atom();
		for (int i=0;i<Atoms.size();i++)
		{
			atom = (Atom)Atoms.get(i);
			String name = atom.getName();
			if (name.equals(DOMAIN_ATOMNAME)) found = true;
		}
		assertTrue("Atom Code found in list", found);
	}

	@Test
	public final void testSetName() {
		String setName="AtomName";
		setAtom.setName(setName);
		String name = "";
		name = setAtom.getName();
		assertTrue("Code set",name.equals(setName));
	}

	@Test
	public final void testGetOrigin() {
		assertNotNull("Atoms should be returned", Atoms);
		assertTrue("Atoms list should have values", Atoms.size()>0);
		boolean found = false;
		Atom atom = new Atom();
		for (int i=0;i<Atoms.size();i++)
		{
			atom = (Atom)Atoms.get(i);
			String origin = atom.getOrigin();
			if (origin.equals(DOMAIN_ATOMSOURCE)) found = true;
		}
		assertTrue("Atom Origin found in list", found);
		
	}

	@Test
	public final void testSetOrigin() {
		String setOrigin="AtomName";
		setAtom.setOrigin(setOrigin);
		String origin = "";
		origin = setAtom.getOrigin();
		assertTrue("Code set",origin.equals(setOrigin));
	}

	@Test
	public final void testGetSource() {
		assertNotNull("Atoms should be returned", Atoms);
		assertTrue("Atoms list should have values", Atoms.size()>0);
		boolean found = false;
		Atom atom = new Atom();
		for (int i=0;i<Atoms.size();i++)
		{
			atom = (Atom)Atoms.get(i);
			Source atomsource = atom.getSource();
			assertNotNull("Atom has source", atomsource);
			assertNotNull("Atom source has abbreviation", atomsource.getAbbreviation());
			if (atomsource.getAbbreviation().equals(DOMAIN_ATOMSOURCE)) found = true;
		}
		assertTrue("Atom Source found in list", found);
	}

	@Test
	public final void testSetSource() {
		String setAbbr = "atm";
		String setCode = "x4321";
		String setDesc = "A test for atom Set Source";
		
		Source atomSource = new Source();
		atomSource.setAbbreviation(setAbbr);
		atomSource.setCode(setCode);
		atomSource.setDescription(setDesc);
		

		setAtom.setSource(atomSource);
		assertTrue("Source abbrev is accurate", setAtom.getSource().getAbbreviation().equals(setAbbr));
		assertTrue("Source code is accurate", setAtom.getSource().getCode().equals(setCode));
		assertTrue("Source desc is accurate", setAtom.getSource().getDescription().equals(setDesc));
	}

}
