package gov.nih.nci.evs.domain;

import static org.junit.Assert.*;

import java.util.ArrayList;

import gov.nih.nci.evs.EVSQueryServiceTestCase;

import org.junit.Test;

public class DefinitionTest extends EVSQueryServiceTestCase{
    
	final static String testID = "domain_DefinitionTest";
	ArrayList definitions = EVSQueryServiceTestCase.getMetaThesaurusConcept().getDefinitionCollection();
	Definition setDefinition = new Definition();
    @Override
    protected String getTestID()
    {
        return testID;
    }

	@Test
	public final void testGetDefinition() {
		assertNotNull("Definitions should be returned", definitions);
		assertTrue("Definitions list should have values", definitions.size()>0);
		Definition definition = new Definition();
		definition = (Definition)definitions.get(0);
		String def = definition.getDefinition();
		assertTrue("Definition has text", def.length()>0);
	}

	@Test
	public final void testSetDefinition() {
		String setDef="Definition text";
		setDefinition.setDefinition(setDef);
		String def = "";
		def = setDefinition.getDefinition();
		assertTrue("Definition set",def.equals(setDef));
	}

	@Test
	public final void testGetSource() {
		assertNotNull("Definitions should be returned", definitions);
		assertTrue("Definitions list should have values", definitions.size()>0);
		Definition definition = new Definition();
		boolean found = false;
		for (int i=0;i<definitions.size();i++)
		{
			definition = (Definition)definitions.get(i);
			Source source = definition.getSource();
			String name = source.getAbbreviation();
			if (name.equals("MSH")) found = true;
		}
		assertTrue("Source MSH found in list", found);

	}

	@Test
	public final void testSetSource() {
		String setAbbr = "defi";
		String setCode = "x4321";
		String setDesc = "A test for Definition Set Source";
		
		Source defSource = new Source();
		defSource.setAbbreviation(setAbbr);
		defSource.setCode(setCode);
		defSource.setDescription(setDesc);
		

		setDefinition.setSource(defSource);
		assertTrue("Source abbrev is accurate", setDefinition.getSource().getAbbreviation().equals(setAbbr));
		assertTrue("Source code is accurate", setDefinition.getSource().getCode().equals(setCode));
		assertTrue("Source desc is accurate", setDefinition.getSource().getDescription().equals(setDesc));
	}

}
