package gov.nih.nci.evs.domain;

import static org.junit.Assert.*;

import java.util.ArrayList;
import java.util.Vector;

import gov.nih.nci.evs.EVSQueryServiceTestCase;

import org.junit.Test;



public class PropertyTest extends EVSQueryServiceTestCase{
    Vector<Property> properties = EVSQueryServiceTestCase.getDescLogicConcept().getPropertyCollection();
    Property setProp = new Property();
	final static String testID = "domain_PropertyTest";

    @Override
    protected String getTestID()
    {
        return testID;
    }

	@Test
	public final void testGetName() {
		assertNotNull("properties should be returned", properties);
		assertTrue("properties list should have values", properties.size()>0);
		boolean found = false;
		Property property = new Property();
		for (int i=0;i<properties.size();i++)
		{
			property = (Property)properties.elementAt(i);
			String name = property.getName();
			if (name.equals("primitive")) found = true;
		}
		assertTrue("Property Name primitive found in list", found);
		
	}

	@Test
	public final void testSetName() {
		String setName="PropertyName";
		setProp.setName(setName);
		String name = "";
		name = setProp.getName();
		assertNotNull("Name returned", name);
		assertTrue("name set",name.equals(setName));
	}

	@Test
	public final void testGetValue() {
		assertNotNull("properties should be returned", properties);
		assertTrue("properties list should have values", properties.size()>0);
		boolean found = false;
		Property property = new Property();
		for (int i=0;i<properties.size();i++)
		{
			property = (Property)properties.elementAt(i);
			String name = property.getValue();
			if (name.equals(DOMAIN_CONCEPT_NAME)) found = true;
		}
		assertTrue("Property Value found in list", found);

	}

	@Test
	public final void testSetValue() {
		String setValue="PropertyName";
		setProp.setName(setValue);
		String value = "";
		value = setProp.getName();
		assertNotNull("Name returned", value);
		assertTrue("name set",value.equals(setValue));
	}

	@Test
	public final void testGetQualifierCollection() {
		assertNotNull("properties should be returned", properties);
		assertTrue("properties list should have values", properties.size()>0);
		boolean found = false;
		Property property = new Property();
		for (int i=0;i<properties.size();i++)
		{
			property = (Property)properties.elementAt(i);
			String name = property.getName();
			String value = property.getValue();
			if (value.equals(DOMAIN_CONCEPT_NAME) && name.equals("FULL_SYN"))
			{
				Vector<Qualifier> quals = property.getQualifierCollection();
				assertNotNull("qualifiers should be returned", quals);
				assertTrue("qualifiers should have values", quals.size()>0);
				Qualifier qual = new Qualifier();
				for (int j=0;j<quals.size();j++)
				{
					qual = (Qualifier)quals.elementAt(j);
					String qualname = qual.getName();
					String qualvalue = qual.getValue();
					if (qualname.equals(DOMAIN_QUAL_NAME) && qualvalue.equals(DOMAIN_QUAL_VALUE)) found = true;
				}
			}
		}
		assertTrue("Qualifier Value found in list", found);
	}

	@Test
	public final void testSetQualifierCollection() {
		Qualifier qual1 = new Qualifier();
		String name1 = "QualName1";
		String value1 = "QualValue1";
		qual1.setName(name1);
		qual1.setValue(value1);
		
		Qualifier qual2 = new Qualifier();
		String name2 = "QualName2";
		String value2 = "QualValue2";
		qual2.setName(name2);
		qual2.setValue(value2);
		
		Vector<Qualifier> setQuals = new Vector<Qualifier>();
		setQuals.add(0,qual1);
		setQuals.add(1,qual2);
		
		setProp.setQualifierCollection(setQuals);
		
		Vector<Qualifier> quals = setProp.getQualifierCollection();
		assertNotNull("Qualifiers returned",quals);
		assertTrue("Qualifer is correct", quals.elementAt(0).getValue().equals(value1));
		assertTrue("Qualifier name is correct", quals.elementAt(1).getName().equals(name2));
	}

}
