package gov.nih.nci.evs.domain;

import static org.junit.Assert.*;

import java.util.ArrayList;

import gov.nih.nci.evs.EVSQueryServiceTestCase;

import org.junit.Test;

public class SemanticTypeTest extends EVSQueryServiceTestCase{
    
	final static String testID = "domain_SemanticTypeTest";
    ArrayList<SemanticType> semanticTypes = EVSQueryServiceTestCase.getMetaThesaurusConcept().getSemanticTypeCollection();
    
    SemanticType setSemType = new SemanticType();
    
    @Override
    protected String getTestID()
    {
        return testID;
    }

	@Test
	public final void testGetId() {
		assertNotNull("semanticTypes should be returned", semanticTypes);
		assertTrue("semanticTypes list should have values", semanticTypes.size()>0);
		boolean found = false;
		SemanticType semanticType = new SemanticType();
		for (int i=0;i<semanticTypes.size();i++)
		{
			semanticType = (SemanticType)semanticTypes.get(i);
			String name = semanticType.getId();
			if (name.equals(DOMAIN_SEMANTIC_ID)) found = true;
		}
		assertTrue("SemanticType found in list", found);
	}

	@Test
	public final void testSetId() {
		String setId="ConceptId";
		setSemType.setId(setId);
		String id = "";
		id = setSemType.getId();
		assertNotNull("Name returned", id);
		assertTrue("name set",id.equals(setId));
	}

	@Test
	public final void testGetName() {
		assertNotNull("semanticTypes should be returned", semanticTypes);
		assertTrue("semanticTypes list should have values", semanticTypes.size()>0);
		boolean found = false;
		SemanticType semanticType = new SemanticType();
		for (int i=0;i<semanticTypes.size();i++)
		{
			semanticType = (SemanticType)semanticTypes.get(i);
			String name = semanticType.getName();
			if (name.equals(DOMAIN_SEMANTIC_TYPE)) found = true;
		}
		assertTrue("SemanticType found in list", found);
	}

	@Test
	public final void testSetName() {
		String setName="ConceptName";
		setSemType.setName(setName);
		String name = "";
		name = setSemType.getName();
		assertNotNull("Name returned", name);
		assertTrue("name set",name.equals(setName));
	}

}
