package gov.nih.nci.evs.domain;

import static org.junit.Assert.*;

import java.util.ArrayList;

import gov.nih.nci.evs.EVSQueryServiceTestCase;

import org.junit.Test;

public class SourceTest extends EVSQueryServiceTestCase{
    
	final static String testID = "domain_SourceTest";
    ArrayList<Source> sources = EVSQueryServiceTestCase.getMetaThesaurusConcept().getSourceCollection();
    Source setSource = new Source();
    
    @Override
    protected String getTestID()
    {
        return testID;
    }

	@Test
	public final void testGetAbbreviation() {
		assertNotNull("sources should be returned", sources);
		assertTrue("sources list should have values", sources.size()>0);
		boolean found = false;
		Source source = new Source();
		for (int i=0;i<sources.size();i++)
		{
			source = (Source)sources.get(i);
			String abrev = source.getAbbreviation();
			assertNotNull("Source has abbreviation",abrev);
			if (abrev.equals(DOMAIN_AVAILABLE_SOURCE)) found = true;
		}
		assertTrue("Source found in list", found);
	}

	@Test
	public final void testSetAbbreviation() {
		String setAbbr="SourceAbbr";
		setSource.setAbbreviation(setAbbr);
		String abbr = "";
		abbr = setSource.getAbbreviation();
		assertNotNull("Abbreviation returned", abbr);
		assertTrue("Abbreviation set",abbr.equals(setAbbr));
	}

	@Test
	public final void testGetCode() {
		assertNotNull("sources should be returned", sources);
		assertTrue("sources list should have values", sources.size()>0);
		boolean found = false;
		Source source = new Source();
		for (int i=0;i<sources.size();i++)
		{
			source = (Source)sources.get(i);
			String code = source.getCode();
			assertNotNull("Source has code",code);
			if (code.equals(DOMAIN_AVAILABLE_SOURCE)) found = true;
		}
		assertTrue("Source found in list", found);
	}

	@Test
	public final void testSetCode() {
		String setCode="SourceCode";
		setSource.setAbbreviation(setCode);
		String code = "";
		code = setSource.getAbbreviation();
		assertNotNull("Code returned", code);
		assertTrue("code set",code.equals(setCode));
	}

	@Test
	public final void testGetDescription() {
		assertNotNull("sources should be returned", sources);
		assertTrue("sources list should have values", sources.size()>0);
		boolean found = false;
		Source source = new Source();
		for (int i=0;i<sources.size();i++)
		{
			source = (Source)sources.get(i);
			String desc = source.getDescription();
			assertNotNull("Source has Description", desc);
			if (desc.equals(DOMAIN_SOURCE_DEF)) found = true;
		}
		assertTrue("Source found in list", found);
	}

	@Test
	public final void testSetDescription() {
		String setDesc="SourceCode";
		setSource.setDescription(setDesc);
		String desc = "";
		desc = setSource.getDescription();
		assertNotNull("Description returned", desc);
		assertTrue("Description set",desc.equals(setDesc));
	}

}
