package gov.nih.nci.evs.metadata;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;

import gov.nih.nci.evs.EVSQueryServiceHolder;
import gov.nih.nci.evs.EVSQueryServiceTestCase;
import gov.nih.nci.evs.query.EVSQuery;
import gov.nih.nci.evs.query.EVSQueryImpl;

/**
 * The Class MetadataTest.
 */
public class MetadataTest extends EVSQueryServiceTestCase{
    final static String testID = "MetadataTest";

    @Override
    protected String getTestID()
    {
        return testID;
    }
    
    /**
     * This method will test retrieve AllAssociationTypes
     *  
     */
    public void testAllAssociationTypes() {
    	List evsResults = new ArrayList();
		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         

        try {
			EVSQuery evsQuery = new EVSQueryImpl();		
			evsQuery.getAllAssociationTypes(vocabName);
    		evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
            assertNotNull("null",evsResults);
            assertTrue("size",evsResults.size()>0);
            
            } catch (Exception ex) {fail("Exception thrown");
                System.out.println("testAllAssociationTypes throws Exception = " + ex);
            }
      
    }
    
    /**
     * This method will test retrieve AllConceptAssociationQualifierTypes
     *  
     */
    public void testAllConceptAssociationQualifierTypes() {
		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
		List evsResults = new ArrayList();

        try {
			EVSQuery evsQuery = new EVSQueryImpl();			
			evsQuery.getAllConceptAssociationQualifierTypes(vocabName);
			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
            assertNotNull("null",evsResults);
            assertTrue("size",evsResults.size()>0);
            } 
        	catch (Exception ex) {fail("Exception thrown");
                System.out.println("testAllConceptAssociationQualifierTypes throws Exception = " + ex);
            }
    }
 
    
    /**
     * This method will test retrieve AllConceptAssociationTypes
     *  
     */
    public void testAllConceptAssociationTypes() {
		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
		List evsResults = new ArrayList();

        try {
			EVSQuery evsQuery = new EVSQueryImpl();
			evsQuery.getAllConceptAssociationTypes(vocabName);
			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
            assertNotNull("null",evsResults);
            assertTrue("size",evsResults.size()>0);
            
            } catch (Exception ex) {fail("Exception thrown");
                System.out.println("testAllConceptAssociationTypes throws Exception = " + ex);
            }
    }
    

    /**
     * This method will test retrieve AllConceptPropertyQualifierTypes
     *  
     */

    	public void testAllConceptPropertyQualifierTypes() {
    		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
     		List evsResults = new ArrayList();

            try {
    			EVSQuery evsQuery = new EVSQueryImpl();
    			evsQuery.getAllConceptPropertyQualifierTypes(vocabName);
    			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                assertNotNull("null",evsResults);
                assertTrue("size",evsResults.size()>0);
                
                } catch (Exception ex) {fail("Exception thrown");
                    System.out.println("testAllConceptPropertyQualifierTypes throws Exception = " + ex);
                }
    	}
    	
    	
        /**
         * This method will test retrieve AllConceptPropertyTypes
         *  
         */

        public void testAllConceptPropertyTypes() {
    		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
    		List evsResults = new ArrayList();

                try {
        			EVSQuery evsQuery = new EVSQueryImpl();
        			evsQuery.getAllConceptPropertyTypes(vocabName);
        			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                    assertNotNull("null",evsResults);
                    assertTrue("size",evsResults.size()>0);
                    
                    } catch (Exception ex) {fail("Exception thrown");
                        System.out.println("testAllConceptPropertyTypes throws Exception = " + ex);
                    }
        }
        
        /**
         * This method will test retrieve AllLicenses
         *  
         */

        public void testgetAllLicenses_NCI() {
     		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
    		List evsResults = new ArrayList();

                try {
        			EVSQuery evsQuery = new EVSQueryImpl();

    	    		evsQuery.getAllLicenses(vocabName,"*");
    	    		evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
    	            assertNotNull("null",evsResults);
    	            assertTrue("size",evsResults.size()>0);
    	            
                    } catch (Exception ex) {fail("Exception thrown");
                        System.out.println("testgetAllLicenses_NCI throws Exception = " + ex);
                    }
        }
        
        /**
         * This method will test retrieve AllQualifierTypes
         *  
         */

        public void testAllQualifierTypes() {
    		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
    		List evsResults = new ArrayList();

                try {
                	
        			EVSQuery evsQuery = new EVSQueryImpl();
        			evsQuery.getAllQualifierTypes(vocabName);
        			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                    assertNotNull("null",evsResults);
                    assertTrue("size",evsResults.size()>0);
                    } 
                catch (Exception ex) {fail("Exception thrown");
                        System.out.println("testAllQualifierTypes throws Exception = " + ex);
                    }
        }
        
        /**
         * This method will test retrieve getAllRoleNames
         *  
         */

        public void testgetAllRoleNames() {
    		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
     		List evsResults = new ArrayList();

                try {
        			EVSQuery evsQuery = new EVSQueryImpl();
        			evsQuery.getAllRoleNames(vocabName);
        			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                    assertNotNull("null",evsResults);
                    assertTrue("size",evsResults.size()>0);
                    
                    } catch (Exception ex) {fail("Exception thrown");
                        System.out.println("testgetAllRoleNames throws Exception = " + ex);
                    }
        }
        
        /**
         * This method will test getAllSynonymTypes
         *  
         */
        public void testgetAllSynonymTypes() {
    		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
    		List evsResults = new ArrayList();

            try {
    			EVSQuery evsQuery = new EVSQueryImpl();
    			evsQuery.getAllSynonymTypes(vocabName);
    			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                //This method returns an empty Vector, regardless of input.  Should be deprecated for lexbig
    			assertNotNull("null",evsResults);
                assertTrue("size",evsResults.size()==0);
                
            } catch (Exception ex) {fail("Exception thrown");
                    System.out.println("testgetAllSynonymTypes throws Exception = " + ex);
                }
        }
        /**
         * This method will test getAllTermAssociationQualifierTypes
         *  
         */
        public void testgetAllTermAssociationQualifierTypes() {
     		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
     		List evsResults = new ArrayList();
    		
            try {
    			EVSQuery evsQuery = new EVSQueryImpl();
    			evsQuery.getAllTermAssociationQualifierTypes(vocabName);
    			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                assertNotNull("null",evsResults);
                assertTrue("size",evsResults.size()>0);
                
            	} catch (Exception ex) {fail("Exception thrown");
                    System.out.println("testgetAllTermAssociationQualifierTypes throws Exception = " + ex);
                }
        }    /**
     
        /**
         * This method will test getAllTermPropertyQualifierTypes
         *  
         */  
        public void testgetAllTermPropertyQualifierTypes() {
     		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
    		List evsResults = new ArrayList();
    		
            try {
    			EVSQuery evsQuery = new EVSQueryImpl();
    			evsQuery.getAllTermPropertyQualifierTypes(vocabName);
    			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                assertNotNull("null",evsResults);
                assertTrue("size",evsResults.size()>0);
                } 
            catch (Exception ex) {fail("Exception thrown");
                    System.out.println("testgetAllTermPropertyQualifierTypes throws Exception = " + ex);
                }
            
        }
         /**
         * This method will test getAllTermPropertyTypes
         *  
         */
        public void testgetAllTermPropertyTypes() {
    		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
    		List evsResults = new ArrayList();
    		
            try {
    			EVSQuery evsQuery = new EVSQueryImpl();
    			evsQuery.getAllTermPropertyTypes(vocabName);
    			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                assertNotNull("null",evsResults);
                assertTrue("size",evsResults.size()>0);
                } 
            catch (Exception ex) {fail("Exception thrown");
                    System.out.println("testgetAllTermPropertyTypes throws Exception = " + ex);
                }
               
        }
        
        /**
         * Test getAllLicenses for meddra.
         */
        public void testgetAllLicenses_Meddra() {
    		String vocabName = EVSQueryServiceTestCase.MEDDRA_SCHEME;         
    		List evsResults = new ArrayList();

            try {
        			EVSQuery evsQuery = new EVSQueryImpl();
//        			gov.nih.nci.evs.security.SecurityToken token = new gov.nih.nci.evs.security.SecurityToken();
//       			token.setAccessToken(EVSQueryServiceTestCase.MEDDRA_TOKEN);
//        			evsQuery.addSecurityToken(EVSQueryServiceTestCase.MEDDRA_SCHEME,token);

    	    		evsQuery.getAllLicenses(vocabName,"*");
    	    		evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
    	            assertNotNull("null",evsResults);
    	            assertTrue("size",evsResults.size()>0);
    	            } catch (Exception ex) {fail("Exception thrown");
                        System.out.println("testgetAllLicenses_Meddra throws Exception = " + ex);
                    }
                    
        }
        
        /**
         * This method will test getRelatedConcepts
         *  
         */
        public void testgetSemanticTypes() {
//    		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
    		List evsResults = new ArrayList();
    		
            try {
    			EVSQuery evsQuery = new EVSQueryImpl();
    			evsQuery.getSemanticTypes();
    			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                assertNotNull("null",evsResults);
                assertTrue("size",evsResults.size()>0);
                } 
            catch (Exception ex) {fail("Exception thrown");
                    System.out.println("testgetSemanticTypes throws Exception = " + ex);
                }
                
        } 
        
        /**
         * This method will test getVocabularyHost
         * @deprecated - host no longer supported by LexBIG 
         */@Deprecated
        public void testgetVocabularyHost() {
    		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
    		List evsResults = new ArrayList();

            try {
    			EVSQuery evsQuery = new EVSQueryImpl();
    			evsQuery.getVocabularyHost(vocabName);
    			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                assertNotNull("null",evsResults);
                assertTrue("size",evsResults.size()>0);
                } 
            catch (Exception ex) {fail("Exception thrown");
                    System.out.println("testgetVocabularyHost throws Exception = " + ex);
                }
            
        }
         /**
         * This method will test getVocabularyNames
         *  
         */
        public void testgetVocabularyNames() {
    		List evsResults = new ArrayList();
    		
            try {
    			EVSQuery evsQuery = new EVSQueryImpl();
    			evsQuery.getVocabularyNames();
    			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                assertNotNull("null",evsResults);
                assertTrue("size",evsResults.size()>0);
                } 
            catch (Exception ex) {fail("Exception thrown");
                    System.out.println("testgetVocabularyNames throws Exception = " + ex);
                }
            
        }
         /**
         * This method will test getVocabularyPort
         *  @deprecated - port not supported by LexBIG
         */@Deprecated
        public void testgetVocabularyPort() {
    		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
    		List evsResults = new ArrayList();

            try {
    			EVSQuery evsQuery = new EVSQueryImpl();
    			evsQuery.getVocabularyPort(vocabName);
    			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                assertNotNull("null",evsResults);
                assertTrue("size",evsResults.size()>0);
                } 
            catch (Exception ex) {fail("Exception thrown");
                    System.out.println("testgetVocabularyPort throws Exception = " + ex);
                }
            
        }
        /**
         * This method will test getVocabularyVersion
         *  
         */
        public void testgetVocabularyVersion() {
    		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
    		List evsResults = new ArrayList();

            try {
    			EVSQuery evsQuery = new EVSQueryImpl();
    			evsQuery.getVocabularyVersion(vocabName);
    			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                assertNotNull("null",evsResults);
                assertTrue("size",evsResults.size()>0);
                } 
            catch (Exception ex) {fail("Exception thrown");
                    System.out.println("testgetVocabularyVersion throws Exception = " + ex);
                }
                
        }
        

    	@Test
    	public void testGetAllVocabularies() {
    		List evsResults = new ArrayList();
    		
            try {
    			EVSQuery evsQuery = new EVSQueryImpl();
    			evsQuery.getAllVocabularies();
    			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                assertNotNull("null",evsResults);
                assertTrue("size",evsResults.size()>0);
                } 
            catch (Exception ex) {fail("Exception thrown");
                    System.out.println("testgetVocabularyNames throws Exception = " + ex);
                }
    	}

    	@Test
    	public void testGetVocabularyByName() {
    		List evsResults = new ArrayList();
    		
            try {
    			EVSQuery evsQuery = new EVSQueryImpl();
    			evsQuery.getVocabularyByName(EVSQueryServiceTestCase.THES_LOCAL);
    			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                assertNotNull("null",evsResults);
                assertTrue("size",evsResults.size()>0);
                } 
            catch (Exception ex) {fail("Exception thrown");
                    System.out.println("testgetVocabularyNames throws Exception = " + ex);
                }
    	}


    	@Test
    	public void testGetAllPropertyTypes() {
    		String vocabName = EVSQueryServiceTestCase.THES_SCHEME;         
    		List evsResults = new ArrayList();
    		
            try {
    			EVSQuery evsQuery = new EVSQueryImpl();
    			evsQuery.getAllPropertyTypes(vocabName);
    			evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
                assertNotNull("null",evsResults);
                assertTrue("size",evsResults.size()>0);
                } 
            catch (Exception ex) {fail("Exception thrown");
                    System.out.println("testgetAllTermPropertyTypes throws Exception = " + ex);
                }
    	}

}
