package gov.nih.nci.evs.query;
import java.net.URL;
import org.apache.axis.client.Service;
import org.apache.axis.client.Call;
import org.apache.axis.encoding.XMLType;

import javax.xml.namespace.QName;
import javax.xml.rpc.ParameterMode;
import javax.xml.rpc.NamespaceConstants;

import gov.nih.nci.evs.EVSQueryServiceTestCase;
import gov.nih.nci.evs.domain.*;
import gov.nih.nci.evs.security.*;
import java.util.*;
import gov.nih.nci.evs.util.*;



/**
 * <!-- LICENSE_TEXT_START -->
* Copyright 2001-2004 SAIC. Copyright 2001-2003 SAIC. This software was developed in conjunction with the National Cancer Institute,
* and so to the extent government employees are co-authors, any rights in such works shall be subject to Title 17 of the United States Code, section 105.
* Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
* 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the disclaimer of Article 3, below. Redistributions
* in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other
* materials provided with the distribution.
* 2. The end-user documentation included with the redistribution, if any, must include the following acknowledgment:
* "This product includes software developed by the SAIC and the National Cancer Institute."
* If no such end-user documentation is to be included, this acknowledgment shall appear in the software itself,
* wherever such third-party acknowledgments normally appear.
* 3. The names "The National Cancer Institute", "NCI" and "SAIC" must not be used to endorse or promote products derived from this software.
* 4. This license does not authorize the incorporation of this software into any third party proprietary programs. This license does not authorize
* the recipient to use any trademarks owned by either NCI or SAIC-Frederick.
* 5. THIS SOFTWARE IS PROVIDED "AS IS," AND ANY EXPRESSED OR IMPLIED WARRANTIES, (INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE) ARE DISCLAIMED. IN NO EVENT SHALL THE NATIONAL CANCER INSTITUTE,
* SAIC, OR THEIR AFFILIATES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
* WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * <!-- LICENSE_TEXT_END -->
 */

/**
 * @author Shaziya Muhsin
 */

/**
 * EVSWSClient class demonstrates EVS Web Service calls made to the caCOREService.
 */
public class WebServiceTest extends EVSQueryServiceTestCase{
    final static String testID = "WebServiceTest";

    @Override
    protected String getTestID()
    {
        return testID;
    }
    
    

    String endpointURL ="http://cbvapp-d1007.nci.nih.gov:19080/evsapi41/services/evsapi41Service";
    String methodName = "queryObject";
    
    Service service = new Service();
    Call call = null;
    /**
     * @param args
     */
    public WebServiceTest() {
        try{
//            System.out.println("\n--------------------");
//            System.out.println("EVS WEB SERVICE TEST");
//            System.out.println("\n--------------------\n");
//            
////            String endpointURL ="http://localhost:8080/evsapi/services/evsapi40Service";
//            String endpointURL ="http://cbvapp-d1007.nci.nih.gov:19080/evsapi41/services/evsapi41Service";
//
//            String methodName = "queryObject";
//            Service service = new Service();
            call = (Call)service.createCall();
            call.setTargetEndpointAddress(new java.net.URL(endpointURL));
            call.setOperationName(new QName("EVSWebService",methodName));
            call.addParameter("arg0", XMLType.XSD_STRING, ParameterMode.IN);
            call.addParameter("arg1",XMLType.XSD_ANYTYPE, ParameterMode.IN);
            List printList = new ArrayList();
            //PrintUtils p = new PrintUtils();

    QName qnMTC = new QName("urn:domain.evs.nci.nih.gov", "MetaThesaurusConcept");
    QName qnSource = new QName("urn:domain.evs.nci.nih.gov", "Source");
    QName qnSemanticType = new QName("urn:domain.evs.nci.nih.gov", "SemanticType");
    QName qnDefinition = new QName("urn:domain.evs.nci.nih.gov", "Definition");
    QName qnAtom = new QName("urn:domain.evs.nci.nih.gov", "Atom");
    QName qnMTCArr = new QName("urn:domain.evs.nci.nih.gov","ArrayOf_tns1_MetaThesaurusConcept");
    QName qnSourceArr = new QName("urn:domain.evs.nci.nih.gov","ArrayOf_tns1_Source");
    QName qnSemanticTypeArr = new QName("urn:domain.evs.nci.nih.gov","ArrayOf_tns1_SemanticType");
    QName qnDefinitionArr = new QName("urn:domain.evs.nci.nih.gov","ArrayOf_tns1_Definition");
    QName qnAtomArr = new QName("urn:domain.evs.nci.nih.gov","ArrayOf_tns1_Atom");
    QName qnRole = new QName("urn:domain.evs.nci.nih.gov", "Role");
    QName qnDLC = new QName("urn:domain.evs.nci.nih.gov","DescLogicConcept");
    QName qnProperty = new QName("urn:domain.evs.nci.nih.gov","Property");
    QName qnTreeNode = new QName("urn:domain.evs.nci.nih.gov","TreeNode");
    QName qnEdgeProperties = new QName("urn:domain.evs.nci.nih.gov","EdgeProperties");
    QName qnQualifier= new QName("urn:domain.evs.nci.nih.gov","Qualifier");
    QName qnAssociation = new QName("urn:domain.evs.nci.nih.gov","Association");
    QName qnSilo = new QName("urn:domain.evs.nci.nih.gov","Silo");
    QName qnVocabulary = new QName("urn:domain.evs.nci.nih.gov","Vocabulary");
    QName qnHistory = new QName("urn:domain.evs.nci.nih.gov","History");
    QName qnHistoryRecord = new QName("urn:domain.evs.nci.nih.gov","HistoryRecord");
    QName qnEditActionDate = new QName("urn:domain.evs.nci.nih.gov","EditActionDate");
    QName qnAttributeSetDescriptor = new QName("urn:domain.evs.nci.nih.gov","AttributeSetDescriptor");
    QName qnRoleArr = new QName("urn:domain.evs.nci.nih.gov","ArrayOf_tns1_Role");
    QName qnDLCArr = new QName("urn:domain.evs.nci.nih.gov","ArrayOf_tns1_DescLogicConcept");
    QName qnPropertyArr = new QName("urn:domain.evs.nci.nih.gov","ArrayOf_tns1_Property");
    QName qnQualifierArr = new QName("urn:domain.evs.nci.nih.gov","ArrayOf_tns1_Qualifier");
    QName qnAssociationArr = new QName("urn:domain.evs.nci.nih.gov","ArrayOf_tns1_Association");
    QName qnHistoryArr = new QName("urn:domain.evs.nci.nih.gov","ArrayOf_tns1_History");
    QName qnHistoryRecordArr = new QName("urn:domain.evs.nci.nih.gov","ArrayOf_tns1_HistoryRecord");
    QName qnSiloArr = new QName("urn:domain.evs.nci.nih.gov","ArrayOf_tns1_Silo");
    QName qnHashSet = new QName("urn:domain.evs.nci.nih.gov", "HashSet");
    QName qnStringArr = new QName("EVSWebService","ArrayOf_xsd_string");
    QName qnAnyTypeArr = new QName("EVSWebService","ArrayOf_xsd_anytype");
    QName qnVocabularyArr = new QName("EVSWebService","ArrayOf_tns1_Vocabulary");
    QName qnSecurityToken = new QName("urn:security.evs.nci.nih.gov", "SecurityToken");


    call.registerTypeMapping(SecurityToken.class, qnSecurityToken, new org.apache.axis.encoding.ser.BeanSerializerFactory(SecurityToken.class, qnSecurityToken), new org.apache.axis.encoding.ser.BeanDeserializerFactory(SecurityToken.class, qnSecurityToken));
    call.registerTypeMapping(MetaThesaurusConcept.class, qnMTC, new org.apache.axis.encoding.ser.BeanSerializerFactory(MetaThesaurusConcept.class, qnMTC), new org.apache.axis.encoding.ser.BeanDeserializerFactory(MetaThesaurusConcept.class, qnMTC));
    call.registerTypeMapping(Source.class, qnSource, new org.apache.axis.encoding.ser.BeanSerializerFactory(Source.class, qnSource), new org.apache.axis.encoding.ser.BeanDeserializerFactory(Source.class, qnSource));
    call.registerTypeMapping(Definition.class, qnDefinition, new org.apache.axis.encoding.ser.BeanSerializerFactory(Definition.class, qnDefinition), new org.apache.axis.encoding.ser.BeanDeserializerFactory(Definition.class, qnDefinition));
    call.registerTypeMapping(Atom.class, qnAtom, new org.apache.axis.encoding.ser.BeanSerializerFactory(Atom.class, qnAtom), new org.apache.axis.encoding.ser.BeanDeserializerFactory(Atom.class, qnAtom));
    call.registerTypeMapping(SemanticType.class, qnSemanticType, new org.apache.axis.encoding.ser.BeanSerializerFactory(SemanticType.class, qnSemanticType), new org.apache.axis.encoding.ser.BeanDeserializerFactory(SemanticType.class, qnSemanticType));
    call.registerTypeMapping(MetaThesaurusConcept[].class,qnMTCArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());
    call.registerTypeMapping(Source[].class,qnSourceArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());
    call.registerTypeMapping(Definition[].class,qnDefinitionArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());
    call.registerTypeMapping(Atom[].class,qnAtomArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());
    call.registerTypeMapping(SemanticType[].class,qnSemanticTypeArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());
    call.registerTypeMapping(Role.class, qnRole, new org.apache.axis.encoding.ser.BeanSerializerFactory(Role.class, qnRole), new org.apache.axis.encoding.ser.BeanDeserializerFactory(Role.class, qnRole));
    call.registerTypeMapping(Vocabulary.class, qnVocabulary, new org.apache.axis.encoding.ser.BeanSerializerFactory(Vocabulary.class, qnVocabulary), new org.apache.axis.encoding.ser.BeanDeserializerFactory(Vocabulary.class, qnVocabulary));
    call.registerTypeMapping(Property.class, qnProperty, new org.apache.axis.encoding.ser.BeanSerializerFactory(Property.class, qnProperty), new org.apache.axis.encoding.ser.BeanDeserializerFactory(Property.class, qnProperty));
    call.registerTypeMapping(DescLogicConcept.class, qnDLC, new org.apache.axis.encoding.ser.BeanSerializerFactory(DescLogicConcept.class, qnDLC), new org.apache.axis.encoding.ser.BeanDeserializerFactory(DescLogicConcept.class, qnDLC));
    call.registerTypeMapping(TreeNode.class, qnTreeNode, new org.apache.axis.encoding.ser.BeanSerializerFactory(TreeNode.class, qnTreeNode), new org.apache.axis.encoding.ser.BeanDeserializerFactory(TreeNode.class, qnTreeNode));
    call.registerTypeMapping(EdgeProperties.class, qnEdgeProperties, new org.apache.axis.encoding.ser.BeanSerializerFactory(EdgeProperties.class, qnEdgeProperties), new org.apache.axis.encoding.ser.BeanDeserializerFactory(EdgeProperties.class, qnEdgeProperties));
    call.registerTypeMapping(Qualifier.class, qnQualifier, new org.apache.axis.encoding.ser.BeanSerializerFactory(Qualifier.class, qnQualifier), new org.apache.axis.encoding.ser.BeanDeserializerFactory(Qualifier.class, qnQualifier));
    call.registerTypeMapping(Association.class, qnAssociation, new org.apache.axis.encoding.ser.BeanSerializerFactory(Association.class, qnAssociation), new org.apache.axis.encoding.ser.BeanDeserializerFactory(Association.class, qnAssociation));
    call.registerTypeMapping(Silo.class, qnSilo, new org.apache.axis.encoding.ser.BeanSerializerFactory(Silo.class, qnSilo), new org.apache.axis.encoding.ser.BeanDeserializerFactory(Silo.class, qnSilo));
    call.registerTypeMapping(History.class, qnHistory, new org.apache.axis.encoding.ser.BeanSerializerFactory(History.class, qnHistory), new org.apache.axis.encoding.ser.BeanDeserializerFactory(History.class, qnHistory));
    call.registerTypeMapping(HistoryRecord.class, qnHistoryRecord, new org.apache.axis.encoding.ser.BeanSerializerFactory(HistoryRecord.class, qnHistoryRecord), new org.apache.axis.encoding.ser.BeanDeserializerFactory(HistoryRecord.class, qnHistoryRecord));
    call.registerTypeMapping(AttributeSetDescriptor.class, qnAttributeSetDescriptor, new org.apache.axis.encoding.ser.BeanSerializerFactory(AttributeSetDescriptor.class, qnAttributeSetDescriptor), new org.apache.axis.encoding.ser.BeanDeserializerFactory(AttributeSetDescriptor.class, qnAttributeSetDescriptor));
    call.registerTypeMapping(EditActionDate.class, qnEditActionDate, new org.apache.axis.encoding.ser.BeanSerializerFactory(EditActionDate.class, qnEditActionDate), new org.apache.axis.encoding.ser.BeanDeserializerFactory(EditActionDate.class, qnEditActionDate));
    call.registerTypeMapping(DescLogicConcept[].class,qnDLCArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());
    call.registerTypeMapping(Property[].class,qnPropertyArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());
    call.registerTypeMapping(Qualifier[].class,qnQualifierArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());
    call.registerTypeMapping(Role[].class,qnRoleArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());
    call.registerTypeMapping(Association[].class,qnAssociationArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());
    call.registerTypeMapping(History[].class,qnHistoryArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());
    call.registerTypeMapping(HistoryRecord[].class,qnHistoryRecordArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());
    call.registerTypeMapping(Silo[].class,qnSiloArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());
    call.registerTypeMapping(HashSet.class, qnHashSet, new org.apache.axis.encoding.ser.BeanSerializerFactory(HashSet.class, qnHashSet), new org.apache.axis.encoding.ser.BeanDeserializerFactory(HashSet.class, qnHashSet));
    call.registerTypeMapping(java.lang.String[].class,qnStringArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());
    call.registerTypeMapping(java.lang.Object[].class,qnAnyTypeArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());

    PrintUtils print = new PrintUtils();

        }  catch(Exception ex){
                ex.printStackTrace();
            System.out.println(ex.getMessage());
            }}
        
        
    public void testSearchDescLogicConceptByCode() {
/************* Thesaurus Test **********************************************************/
//  1. Search for a DescLogicConcept by code
 /***************************************************************************************/
        try {
//            Service service = new Service();
//            Call call = (Call)service.createCall();
//            call.setTargetEndpointAddress(new java.net.URL(endpointURL));
//            call.setOperationName(new QName("EVSWebService",methodName));
//            call.addParameter("arg0", XMLType.XSD_STRING, ParameterMode.IN);
//            call.addParameter("arg1",XMLType.XSD_ANYTYPE, ParameterMode.IN);
    	QName qnDLCArr = new QName("urn:domain.evs.nci.nih.gov","ArrayOf_tns1_DescLogicConcept");
        call.registerTypeMapping(DescLogicConcept[].class,qnDLCArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());

             System.out.println("1. Search DescLogicConcept by code");
             System.out.println("\n----------------------------------------------------------------\n");
             DescLogicConcept dlc = new DescLogicConcept();
             //dlc.setName("ear*");
             dlc.setCode("C9440");
             call.setReturnType(qnDLCArr);
             Object[] thesaurusParams = new Object[]{"gov.nih.nci.evs.domain.DescLogicConcept",dlc};
             DescLogicConcept[] dlcs = (DescLogicConcept[])call.invoke(thesaurusParams);
             assertNotNull("Not Null", dlcs);
             assertTrue("Has values", dlcs.length>0);
             
             char counter = 'a';
             for(DescLogicConcept d: dlcs){
                 System.out.println("\t"+counter+") Concept name: "+ d.getName());
                 System.out.println("\t  code: "+ d.getCode());
                 System.out.println("\t  -------------------------------");
                 counter++;
             }
             System.out.println("Number of items returned from Thesaurus = "+ dlcs.length);
             System.out.println("\n----------------------------------------------------------------\n");

    }  catch(Exception ex){
        ex.printStackTrace();
        fail("Exception thrown");
    }
    }
    
    public void testSeachMetathesaurusByName(){
/************* Metaphrase Test **********************************************************/
//2. Search a MetaThesaurusConcept by Name
/***************************************************************************************/
    	try{    
//            Service service = new Service();
//            Call call = (Call)service.createCall();
//        call.setTargetEndpointAddress(new java.net.URL(endpointURL));
//        call.setOperationName(new QName("EVSWebService",methodName));
//        call.addParameter("arg0", XMLType.XSD_STRING, ParameterMode.IN);
//        call.addParameter("arg1",XMLType.XSD_ANYTYPE, ParameterMode.IN);
            System.out.println("\n----------------------------------------------------------------");
            System.out.println("2.Search Metaphrase by Name");
            System.out.println("\n----------------------------------------------------------------\n");
            QName qnMTCArr = new QName("urn:domain.evs.nci.nih.gov","ArrayOf_tns1_MetaThesaurusConcept");
            call.registerTypeMapping(MetaThesaurusConcept[].class,qnMTCArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());

            MetaThesaurusConcept mtc = new MetaThesaurusConcept();
            //mtc.setName("blood*");
            mtc.setName("Abnormality");
            call.setReturnType(qnMTCArr);

            Object[] metaParams = new Object[]{"MetaThesaurusConcept",mtc};
            MetaThesaurusConcept[] meta = null;
            
                meta = (MetaThesaurusConcept[])call.invoke(metaParams);
                assertNotNull("Not null", meta);
                assertTrue("Has values", meta.length>0);
                
                char counter = 'a';
                for(MetaThesaurusConcept m: meta){
                    System.out.println("\t"+counter+") Concept name: "+ m.getName());
                    System.out.println("\t  code: "+ m.getCui());
                    System.out.println("\t-------------------------------");
                    counter++;
                }
                System.out.println("Size: "+ meta.length);
            }catch(Exception ex){
                ex.printStackTrace();
//                System.out.println("Error: "+ ex);
                fail("Exception thrown");
            }
//            System.out.println("\n----------------------------------------------------------------\n");
    }
    
    public void testGetLicense() {

//GF#9397 KLO, 120607
/************* getLicense Test **********************************************************/
//3. Get license statements of a vocabulary
/***************************************************************************************/
try{
//    Service service = new Service();
//    Call call = (Call)service.createCall();
//    call.setTargetEndpointAddress(new java.net.URL(endpointURL));
//    call.setOperationName(new QName("EVSWebService",methodName));
//    call.addParameter("arg0", XMLType.XSD_STRING, ParameterMode.IN);
//    call.addParameter("arg1",XMLType.XSD_ANYTYPE, ParameterMode.IN);
            System.out.println("\n----------------------------------------------------------------");
            System.out.println("3.getLicense---------------------------------\n");
            QName qnAnyTypeArr = new QName("EVSWebService","ArrayOf_xsd_anytype");
            call.registerTypeMapping(java.lang.Object[].class,qnAnyTypeArr, new org.apache.axis.encoding.ser.ArraySerializerFactory(), new org.apache.axis.encoding.ser.ArrayDeserializerFactory());

            String methodName = "query";

            gov.nih.nci.evs.domain.Vocabulary vocabulary = new Vocabulary();
            vocabulary.setName("MedDRA");

            call.setOperationName(methodName);

//            call.addParameter("arg0", XMLType.XSD_STRING,  ParameterMode.IN);
//            call.addParameter("arg1", XMLType.XSD_ANYTYPE, ParameterMode.IN);
            call.setReturnType( qnAnyTypeArr );

//            String vocabularyName = "NCI_Thesaurus";

            String evsMethod = "getLicense";
            java.lang.Object[] objs = (java.lang.Object[]) call.invoke( new Object[]{evsMethod, (Object) vocabulary} );
            for (int i=0; i<objs.length; i++)
            {
			    String license = (String) objs[i];
                System.out.println("license: " + license);
            }
    }  catch(Exception ex){
        ex.printStackTrace();
//    System.out.println(ex.getMessage());
        fail("Exception thrown");
    }
/****************************************************************************************/


            }


    

}
