package gov.nih.nci.evs.tree;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.Vector;

import gov.nih.nci.evs.EVSQueryServiceHolder;
import gov.nih.nci.evs.EVSQueryServiceTestCase;
import gov.nih.nci.evs.domain.DescLogicConcept;
import gov.nih.nci.evs.domain.Property;
import gov.nih.nci.evs.query.EVSQuery;
import gov.nih.nci.evs.query.EVSQueryImpl;

//import gov.nih.nci.cadsr.cdecurate.tool.EVSSearch;
//import gov.nih.nci.cadsr.cdecurate.tool.EVS_UserBean;
//import gov.nih.nci.cadsr.cdecurate.tool.Tree;
//import gov.nih.nci.cadsr.cdecurate.tool.TreeNode;
//import gov.nih.nci.cadsr.cdecurate.tool.TreeLeaf;

public class CaDSR_TreeTest extends EVSQueryServiceTestCase {

	@Override
	protected String getTestID() {
		// TODO Auto-generated method stub
		return null;
	}
	
    
    public void testgetRootConcepts_checkForChildren() {
    	String vocabName = THES_SCHEME;
    	List evsResults = new ArrayList();
//        Tree dtsTree = new Tree("dtsTree");
        int lastNodeID = 0;
        int level = 0;
    	
        try {
			EVSQuery evsQuery = new EVSQueryImpl();
			evsQuery.getRootConcepts(vocabName,true);
    		evsResults = (List)EVSQueryServiceHolder.instance().getAppService().evsSearch(evsQuery);
            assertNotNull("null",evsResults);
            assertTrue("size",evsResults.size()>0);
            String sDispName = "";
         // For each Root, get the Subconcepts. If subconcepts exist, build a Node
			// object, else build a Leaf object
			if (evsResults != null) {
				for (int j = 0; j < evsResults.size(); j++) {
					DescLogicConcept oDLC = (DescLogicConcept) evsResults.get(j);
					if (oDLC != null) {
						sDispName = getDisplayName(vocabName,
								oDLC, oDLC.getCode());
					}
				}
			}
            
            }
              catch (Exception e) {
                System.out.println("testgetRootConcepts throws Exception = " + e);
                fail(e.toString());
            }
    }

	/**
	 * gets the display name of the concepts
	 * @param dtsVocab STring vocabulary name
	 * @param dlc concepts desclogicobject from the API call
	 * @param sName name of the concept
	 * @return String display name
	 */
	public String getDisplayName(String dtsVocab, DescLogicConcept dlc,
			String sName) {
		String dispName = sName;
		try {
//			Vector vVocabs = (Vector) m_eUser.getVocabNameList();
//			if (vVocabs == null)
//				vVocabs = new Vector();
//
//			//make sure the vocab exists in the list
//			if (!vVocabs.contains(dtsVocab))
//				return sName;
//			//get the property from cadsr
//			Hashtable vHash = (Hashtable) m_eUser.getVocab_Attr();
//			EVS_UserBean eUser = (EVS_UserBean) vHash.get(dtsVocab);
//			if (eUser == null)
//				return sName;
//			String sPropDisp = eUser.getPropNameDisp();
//			if (sPropDisp == null || sPropDisp.equals(""))
//				return dispName;
			//get the value of the display property
			if (dlc == null) //get it from evs query
			{
				EVSQuery query = new EVSQueryImpl();
				query.getPropertyValues(dtsVocab, sName, "Preferred_Name");
				List lstResult = EVSQueryServiceHolder.instance().getAppService().evsSearch(query);
				if (lstResult != null && lstResult.size() > 0)
					return (String) lstResult.get(0);
				else
					return sName;
			} else //get it from dlc object
			{//loop through prop to get the name
				Vector properties = dlc.getPropertyCollection();
				if (properties == null)
					properties = new Vector();
				for (int k = 0; k < properties.size(); k++) {
					Property property = (Property) properties.get(k);
					if (property != null) {
						String propName = property.getName();
						if (propName == null)
							propName = "";
						if (propName.indexOf("Preferred_Name") >= 0) //"Preferred_Name" prop for concept name if not emtpy
						{
							dispName = property.getValue();
							if (dispName != null && !dispName.equals(""))
								return dispName;
							else
								return sName;
						}
					}
				}
			}
		} catch (Exception e) {
			fail(e.toString());
		}
		return sName;
	}
}
