package gov.nih.nci.lexbig.ext;

import gov.nih.nci.system.applicationservice.EVSApplicationService;
//import gov.nih.nci.system.applicationservice.impl.EVSApplicationServiceImpl;
import gov.nih.nci.system.client.ApplicationServiceProvider;

//import org.LexGrid.LexBIG.Impl.LexBIGServiceImpl;
//import org.LexGrid.LexBIG.LexBIGService.LexBIGService;
import gov.nih.nci.ServiceTestCase;

/**
 * The Class AdapterServiceHolder.
 */
public class AdapterServiceHolder {
	private static final String serviceUrl = ServiceTestCase.serviceUrl;
	private static final String _service = "EvsServiceInfo";
	
//	private LexBIGService  lbsi_;
	private static EVSApplicationService evsSvc;
	private DLBAdapter adapter;
	private static AdapterServiceHolder sh_;

	/**
	 * Use this to get an instance of the ServiceHolder. If 'configureForSingleConfig' has not been called,
	 * this will run the tests on all configured databases in the testConfig.props file.
	 *
	 * @return the adapter service holder
	 */
	public static AdapterServiceHolder instance()
	{
		if (sh_ == null)
		{
			//throw new RuntimeException("ServiceHolder has not been configured");
			//sh_ = new ServiceHolder(true, false);

			sh_ = new AdapterServiceHolder();
		}
		return sh_;

	}

	/**
	 * Use this to set up the tests for end user enviroment validation. Only runs the tests once, using their
	 * normal config file.
	 *
	 * @param useCaCore the use ca core
	 */
//	public static void configure(boolean useCaCore)
//	{
//
//		sh_ = new AdapterServiceHolder();
//
//	}

	/**
	 * Use this to set up the tests for end user enviroment validation. Only runs the tests once, using their
	 * normal config file.
	 *
	 */
	public static void configure()
	{
		sh_ = new AdapterServiceHolder();
	}

	private AdapterServiceHolder()
	{
		try{
			evsSvc =  (EVSApplicationService)ApplicationServiceProvider.getApplicationServiceFromUrl(serviceUrl, _service);
			adapter = new DLBAdapter(evsSvc);
			adapter.setVocabulary("NCI_Thesaurus");
		}
		catch (Exception e)
		{
			System.err.println("Problem initiating Test config");
			e.printStackTrace();
			System.exit(-1);
		}
	}

//	private AdapterServiceHolder(boolean useCaCore)
//	{
//		try{
//			evsSvc =  (EVSApplicationService)ApplicationServiceProvider.getApplicationServiceFromUrl(serviceUrl);
//			adapter = new DLBAdapter(evsSvc);
//		}
//		catch (Exception e)
//		{
//			System.err.println("Problem initiating Test config");
//			e.printStackTrace();
//			System.exit(-1);
//		}
//	}

	/**
	 * Gets the dLB adapter.
	 *
	 * @return the DLBAdapter
	 */
	public DLBAdapter getDLBAdapter()
	{
		return adapter;

	}


	/**
	 * Gets the uRL.
	 *
	 * @return the url
	 */
	public static String getURL()
	{
		return serviceUrl;
	}

	/**
	 * Gets the eV ssvc.
	 *
	 * @return the EVSApplicationService
	 */
	public static EVSApplicationService getEVSsvc()
	{
		return evsSvc;
	}


}
