package gov.nih.nci.lexbig.ext;


import gov.nih.nci.lexbig.ext.AdapterServiceHolder;

import junit.framework.Test;
import junit.framework.TestSuite;

import gov.nih.nci.lexbig.ext.history.HistoryTest;
import gov.nih.nci.lexbig.ext.metadata.MetadataTest;
import gov.nih.nci.lexbig.ext.objects.ObjectsTestSuite;
import gov.nih.nci.lexbig.ext.properties.PropertiesTest;
import gov.nih.nci.lexbig.ext.query.QueryTest;
import gov.nih.nci.lexbig.ext.roles.RolesTest;
import gov.nih.nci.lexbig.ext.utils.NavigationUtilsTest;
import gov.nih.nci.lexbig.ext.utils.SearchUtilTest;
import gov.nih.nci.lexbig.ext.utils.SortUtilsTest;
import gov.nih.nci.lexbig.ext.tree.hierarchy.TreeHierarchyTest;
import gov.nih.nci.lexbig.ext.tree.traversal.TreeTraversalTest;

/**
 * The Class AllTests.
 */
public class AllTests_LexbigAdapter {

    /**
     * Suite.
     *
     * @return the test
     *
     * @throws Exception the exception
     */
    public static Test suite() throws Exception
    {
        TestSuite mainSuite = new TestSuite("DLBAdapter validation tests");
        AdapterServiceHolder.configure();

        mainSuite.addTestSuite(HistoryTest.class);
        mainSuite.addTestSuite(MetadataTest.class);
        mainSuite.addTestSuite(PropertiesTest.class);
        mainSuite.addTestSuite(QueryTest.class);
        mainSuite.addTestSuite(RolesTest.class);
        mainSuite.addTestSuite(TreeHierarchyTest.class);
        mainSuite.addTestSuite(TreeTraversalTest.class);
        mainSuite.addTestSuite(NavigationUtilsTest.class);
        mainSuite.addTestSuite(SearchUtilTest.class);
        mainSuite.addTestSuite(SortUtilsTest.class);
        mainSuite.addTest(ObjectsTestSuite.suite());
        return mainSuite;
    }
}
