package gov.nih.nci.lexbig.ext.history;
import gov.nih.nci.lexbig.ext.DLBAdapter;
import gov.nih.nci.lexbig.ext.ConceptHistory;

import java.util.Date;
import java.util.Vector;

import gov.nih.nci.ServiceTestCase;

import gov.nih.nci.lexbig.ext.AdapterServiceHolder;

/**
 * The Class HistoryTest.
 */@SuppressWarnings("deprecation")
public class HistoryTest extends ServiceTestCase{
    final static String testID = "HistoryTest";
    DLBAdapter adapter = AdapterServiceHolder.instance().getDLBAdapter();
	String history_date_str = "09/29/2003";
	String code_hist = "C20889";//"C191";
	String retired_code="C3854";
    @Override
    protected String getTestID()
    {
        return testID;
    }

    /**
     * Test history.
     * 
     * @throws Exception the exception
     */
    public void testHistoryAvailable() throws Exception
    {
		Boolean retval = adapter.setVocabulary(ServiceTestCase.THES_SCHEME,
		                                       ServiceTestCase.THES_VERSION, null);
		if (retval == null || !retval.equals(Boolean.TRUE))
		{
			System.out.println("Unable to connect - program aborts.");
			return;
		}


    		String history_date_str = "09/29/2003";
    		String code_hist = "C20889";//"C191";
    		String retired_code="C3854";
//    		DLBAdapter adapter = AdapterServiceHolder.instance().getDLBAdapter();
    		//isHistoryAvailable(String csName)

    		boolean historyAvailable = adapter.isHistoryAvailable(ServiceTestCase.THES_SCHEME);
     		assertTrue("isHistoryAvailable(String) should be true", historyAvailable);

     		adapter.setVocabulary(ServiceTestCase.THES_SCHEME);
    		historyAvailable = adapter.isHistoryAvailable();
    		assertTrue("isHistoryAvailable() should be true", historyAvailable);
    }
    public void testGetHistoryDates(){
    	//Vector getHistoryDates()
    	Vector v = adapter.getHistoryDates();
    	assertNotNull("getHistoryDates()", v);
    	assertTrue("getHistoryDates() returns values", v.size()>0);
    }
    public void testGetConceptCreationDate(){

    //java.util.Date getConceptCreationDate(String code)
    			Date d = adapter.getConceptCreationDate(code_hist);
    			assertNotNull("getConceptCreationDate(String)", d);
    }
    public void testGetCreationDate(){
    
    			//java.util.Date getCreationDate(String code)
    	Date d = adapter.getCreationDate(code_hist);
    			assertNotNull("getCreationDate(String)", d);
    }
    
    public void testeGetConceptCreateVersionDate(){
    			//java.util.Date getConceptCreateVersionDate(String code)
    			Date d = adapter.getConceptCreateVersionDate(code_hist);
    			assertNotNull("getConceptCreateVersionDate(String)", d);
    }
    public void testgetHistoryStart(){
    			//java.util.Date getHistoryStart()
    			Date d = adapter.getHistoryStart();
    			assertNotNull("getHistoryStart()", d);
    }
    public void testGetHistoryStartDate(){
    			//java.util.Date getHistoryStartDate()
    			Date d = adapter.getHistoryStartDate();
     			assertNotNull("getHistoryStartDate()", d);
    }
    public void testGetHistoryStartBaselineDate(){
    			//java.util.Date getHistoryStartBaselineDate()
    			Date d = adapter.getHistoryStartBaselineDate();
    			assertNotNull("getHistoryStartBaselineDate()", d);
    }
    public void testGetHistoryEnd(){
    			//java.util.Date getHistoryEnd()
    			Date d = adapter.getHistoryEnd();
    			assertNotNull("getHistoryEnd()", d);
    }
    public void testGetHistoryEndDate(){
    			//java.util.Date getHistoryEndDate()
    			Date d = adapter.getHistoryEndDate();
    			assertNotNull("getHistoryEndDate()", d);
    }
    public void testGetHistoryEndBaselineDate(){
    			//java.util.Date getHistoryEndBaselineDate()
    			Date d = adapter.getHistoryEndBaselineDate();
    			assertNotNull("getHistoryEndBaselineDate()", d);
    }
    			

    	public void testGetDescendantCodes(){		
    			// HistoryRecord[] getConceptHistory(
    			java.util.Date iBaselineDate_in = DLBAdapter.stringToDate(history_date_str);
    			java.util.Date fBaselineDate_in = DLBAdapter.stringToDate(history_date_str);
    			try
    			{
    				java.util.Date dateTest = new java.util.Date();
    				java.text.SimpleDateFormat dateFormat = new java.text.SimpleDateFormat("MM/dd/yyyy");
    				dateTest = dateFormat.parse(history_date_str);
    				assertTrue("stringToDate(String)", dateTest.equals(iBaselineDate_in));
    			}
    			catch (java.text.ParseException e)
    			{
    				fail("Input data for test is faulty");
    			}
    			//Vector v getDescendentCodes(String code, boolean atBaseline, Date initialBaseline, Date finalBaseline)
    			Vector v = adapter.getDescendantCodes(code_hist, true, iBaselineDate_in, fBaselineDate_in);
    			assertNotNull("getDescendentCodes(String, boolean,Date,Date)", v);
    			assertTrue("getDescendantCodes has values", v.size()>0);
    	}
    	
    	public void testGetCodeActionChildren(){
    			// Vector getCodeActionChildren(
    			//         String inCode,
    			//         java.util.Date baselineDate_in)
			java.util.Date iBaselineDate_in = DLBAdapter.stringToDate(history_date_str);

    			Vector v = adapter.getCodeActionChildren(code_hist, iBaselineDate_in);
    			assertNotNull("getCodeActionChildren(String, Date)", v);
    			assertTrue("getCodeActionChildren has values", v.size()>0);
    	}
    	public void testGetDescendantCodeActionDates(){
    			// Vector getDescendantCodeActionDates(
    			//         String inCode,
    			//         java.util.Date iBaselineDate_in,
    			//         java.util.Date fBaselineDate_in)
			java.util.Date iBaselineDate_in = DLBAdapter.stringToDate(history_date_str);
			java.util.Date fBaselineDate_in = DLBAdapter.stringToDate(history_date_str);

    			Vector v = adapter.getDescendantCodeActionDates(code_hist, iBaselineDate_in, fBaselineDate_in);
    			assertNotNull("getDescendantCodeActionDates(String, Date, Date)", v);
    			assertTrue("getDescendantCodeActionDates has values", v.size()>0);
    	}

    	public void testGetAncestorCodes_StringStringboolDateDate(){
    		java.util.Date iBaselineDate_in = DLBAdapter.stringToDate("05/25/2007");
    		java.util.Date fBaselineDate_in = DLBAdapter.stringToDate("07/27/2007");
    			Date exactDate = DLBAdapter.stringToDate("06/28/2007");
    			String descendantCode = "C68637";
    			//Vector getAncestorCodes(
    			//       String codingScheme,
    			//       String inCode,
    			//       boolean atBaseline,
    			//       java.util.Date iBaselineDate_in,
    			//       java.util.Date fBaselineDate_in)
    			Vector v = adapter.getAncestorCodes(ServiceTestCase.THES_SCHEME, descendantCode, false, iBaselineDate_in, fBaselineDate_in);
    			assertNotNull("getAncestorCodes(String, String, boolean, Date, Date)", v);
    			assertTrue("getAncestorCodes has values with false", v.size()>0);
  
    			v = adapter.getAncestorCodes(ServiceTestCase.THES_SCHEME, descendantCode, true, iBaselineDate_in, fBaselineDate_in);
    			assertNotNull("getAncestorCodes(String, String, boolean, Date, Date)", v);
    			assertTrue("getAncestorCodes has no values with true", v.size()==0);

    			v = adapter.getAncestorCodes(ServiceTestCase.THES_SCHEME, descendantCode, true, exactDate, exactDate);
    			assertNotNull("getAncestorCodes(String, String, boolean, Date, Date)", v);
    			assertTrue("getAncestorCodes has values with true", v.size()>0);
    	}
    	
    	public void testGetConceptEditActionDates(){
    			// Vector getConceptEditActionDates(
    			//         String code,
    			//         String action)
    			Vector v = adapter.getConceptEditActionDates(code_hist, "split");
    			assertNotNull("getConceptEditActionDates(String, String)", v);
    			assertTrue("getConceptEditActionDates has values", v.size()>0);
    	}
    	
    	public void testGetConceptEditAction(){
    			// Vector getConceptEditAction(String inCode)
    			Vector v = adapter.getConceptEditAction(code_hist);
    			assertNotNull("getConceptEditAction(String)", v);
    			assertTrue("getConceptEditAction has values", v.size()>0);
    	}
    	public void testIsConceptRetired(){
    			// boolean isConceptRetired(String inCode)
    			boolean isRetired = adapter.isConceptRetired(code_hist);
    			assertFalse("isConceptRetired(String)", isRetired);
    			isRetired = adapter.isConceptRetired(retired_code);
    			assertTrue("isConceptRetired(String) retired", isRetired);
    	}
    	public void testIsRetired(){
    			//Boolean isRetired(String inCode)
    			Boolean retired = adapter.isRetired(code_hist);
    			assertFalse("isRetired(String)", retired);
    			retired = adapter.isRetired(retired_code);
    			assertTrue("isRetired(String) retired", retired);
    	}
    	
    	public void testIsConceptEdited(){
    			String code = "C1828";
        		java.util.Date iBaselineDate_in = DLBAdapter.stringToDate("05/25/2007");
        		java.util.Date fBaselineDate_in = DLBAdapter.stringToDate("07/27/2007");
     
    			//boolean isConceptEdited(String inCode,
    			//boolean mrg_splt,
    			//java.util.Date iBaselineDate_in,
    			//java.util.Date fBaselineDate_in)
    			boolean isEdited = adapter.isConceptEdited(code, false, iBaselineDate_in, fBaselineDate_in );
    			assertTrue("isConceptEdited(String, boolean, Date, Date) ", isEdited);
    			//boolean isConceptEdited(String inCode,
    			//boolean mrg_splt,
    			//java.util.Date iBaselineDate_in,
    			//java.util.Date fBaselineDate_in)
    			isEdited = adapter.isConceptEdited(code_hist, false, iBaselineDate_in, fBaselineDate_in );
    			assertFalse("isConceptEdited(String, boolean, Date, Date) ", isEdited);
    			
    			code = "C28012";  //split code
    			//boolean isConceptEdited(String inCode,
    			//boolean mrg_splt,
    			//java.util.Date iBaselineDate_in,
    			//java.util.Date fBaselineDate_in)
    			isEdited = adapter.isConceptEdited(code, true, iBaselineDate_in, fBaselineDate_in );
    			assertTrue("isConceptEdited(String, boolean, Date, Date) ", isEdited);


       			//boolean isConceptEdited(String inCode,
    			//boolean mrg_splt,
    			//java.util.Date iBaselineDate_in,
    			//java.util.Date fBaselineDate_in)
    			isEdited = adapter.isConceptEdited(code_hist, true, iBaselineDate_in, fBaselineDate_in );
    			assertFalse("isConceptEdited(String, boolean, Date, Date) ", isEdited);

    			code = "C66993"; //merge code
    			//boolean isConceptEdited(String inCode,
    			//boolean mrg_splt,
    			//java.util.Date iBaselineDate_in,
    			//java.util.Date fBaselineDate_in)
    			isEdited = adapter.isConceptEdited(code, true, iBaselineDate_in, fBaselineDate_in );
    			assertTrue("isConceptEdited(String, boolean, Date, Date) ", isEdited);

    	}
    	
    	public void testIsEdited(){
   			String code = "C1828";
    		java.util.Date iBaselineDate_in = DLBAdapter.stringToDate("05/25/2007");
    		java.util.Date fBaselineDate_in = DLBAdapter.stringToDate("07/27/2007");

    			// Boolean isEdited(String inCode,
    			//boolean mrg_splt,
    			//java.util.Date iBaselineDate_in,
    			//java.util.Date fBaselineDate_in)
    			Boolean edited = adapter.isEdited(code, false, iBaselineDate_in, fBaselineDate_in );
    			assertTrue("isEdited(String, boolean, Date, Date) ", edited);


    			// Boolean isEdited(String inCode,
    			//boolean mrg_splt,
    			//java.util.Date iBaselineDate_in,
    			//java.util.Date fBaselineDate_in)
    			edited = adapter.isEdited(code_hist, false, iBaselineDate_in, fBaselineDate_in );
    			assertFalse("isEdited(String, boolean, Date, Date) ", edited);


    			code = "C28012";  //split code
    			// Boolean isEdited(String inCode,
    			//boolean mrg_splt,
    			//java.util.Date iBaselineDate_in,
    			//java.util.Date fBaselineDate_in)
    			edited = adapter.isEdited(code, true, iBaselineDate_in, fBaselineDate_in );
    			assertTrue("isEdited(String, boolean, Date, Date) ", edited);
    	
    			code = "C66993"; //merge code
    			// Boolean isEdited(String inCode,
    			//boolean mrg_splt,
    			//java.util.Date iBaselineDate_in,
    			//java.util.Date fBaselineDate_in)
    			edited = adapter.isEdited(code, true, iBaselineDate_in, fBaselineDate_in );
    			assertTrue("isEdited(String, boolean, Date, Date) ", edited);

    			// Boolean isEdited(String inCode,
    			//boolean mrg_splt,
    			//java.util.Date iBaselineDate_in,
    			//java.util.Date fBaselineDate_in)
    			edited = adapter.isEdited(code_hist, true, iBaselineDate_in, fBaselineDate_in );
    			assertFalse("isEdited(String, boolean, Date, Date) ", edited);
    	}
    	public void testGetNumberEditActions_StringDate(){
    			String code = "C1699";
        		java.util.Date iBaselineDate_in = DLBAdapter.stringToDate("05/25/2007");
        		java.util.Date fBaselineDate_in = DLBAdapter.stringToDate("07/27/2007");

    			// int getNumberEditActions(
    			//         String inCode,
    			//         java.util.Date baselineDate_in)
    			int numEditActions = adapter.getNumberEditActions(code, iBaselineDate_in);
    			assertTrue("getNumberEditActions(String, Date)", numEditActions > 0);
    	}
    	public void testGetNumberEditActions_StringDateDate(){
			String code = "C1699";
    		java.util.Date iBaselineDate_in = DLBAdapter.stringToDate("05/25/2007");
    		java.util.Date fBaselineDate_in = DLBAdapter.stringToDate("07/27/2007");

    			// int getNumberEditActions(
    			//       String inCode,
    			//       java.util.Date iBaselineDate_in,
    			//       java.util.Date fBaselineDate_in)
    			int numEditActions = adapter.getNumberEditActions(code, iBaselineDate_in, fBaselineDate_in);
    			assertTrue("getNumberEditActions(String, Date, Date)", numEditActions > 0);
    	}
    	
    	public void testIsValidHistoryDate(){
    		java.util.Date iBaselineDate_in = DLBAdapter.stringToDate("05/25/2007");

    			//boolean isValidHistoryDate(Date historydate)
    			boolean  bool_val = adapter.isValidHistoryDate(iBaselineDate_in);
    			assertTrue("isValidHistoryDate(Date)", bool_val);
    		}

    	public void testGetConceptHistory(){
    		// ConceptHistory getConceptHistory(String conceptcode)
    		ConceptHistory history = adapter.getConceptHistory(code_hist);
    		assertNotNull("getConceptHistory(String)", history);
    	}
    	
    	public void testGetHistoryCollectionByCode(){
    		// Vector getHistoryCollectionbyCode(String vocabularyName, String code) {
    		Vector v = adapter.getHistoryCollectionbyCode(ServiceTestCase.THES_SCHEME, code_hist);
            assertNotNull("getHistoryCollectionbyCode(String, String",v);
            assertTrue("getHistory has values", v.size()>0);

    }
    
    public void testHistory_Zebrafish()
    {
		DLBAdapter adapter = AdapterServiceHolder.instance().getDLBAdapter();
		Boolean retval = adapter.setVocabulary(ServiceTestCase.ZEBRAFISH_SCHEME,
		                                       ServiceTestCase.ZEBRAFISH_VERSION, null);
		if (retval == null || !retval.equals(Boolean.TRUE))
		{
			System.out.println("Unable to connect - program aborts.");
			return;
		}
		boolean historyAvailable = false;
		try {
		historyAvailable = adapter.isHistoryAvailable(ServiceTestCase.ZEBRAFISH_SCHEME);
		assertFalse("isHistoryAvailable(String) should be false", historyAvailable);
		}
		catch (Exception e)
		{
			//This methods is currently programmed to throw an exception if there is no history
			//should probably just throw a false, but it is performin as written.
			
		}

    }
}
