package gov.nih.nci.lexbig.ext.metadata;

import java.util.Vector;

import org.LexGrid.LexBIG.DataModel.Core.NameAndValue;

import gov.nih.nci.lexbig.ext.DLBAdapter;

import gov.nih.nci.lexbig.ext.PropertyType;
import gov.nih.nci.lexbig.ext.RoleType;
import gov.nih.nci.ServiceTestCase;
import gov.nih.nci.lexbig.ext.AdapterServiceHolder;


/**
 * The Class MetadataTest.
 */@SuppressWarnings("deprecation")
public class MetadataTest extends ServiceTestCase{

	 /** The Constant testID. */
	 final static String testID = "MetadataTest";

	 /** The adapter. */
	 DLBAdapter adapter = AdapterServiceHolder.instance().getDLBAdapter();

	 /** The cs name. */
	 String csName = ServiceTestCase.THES_SCHEME;

	 /** The version. */
	 String version = ServiceTestCase.THES_VERSION;

	 /** The tag. */
	 String tag = ServiceTestCase.THES_TAG;

	 /* (non-Javadoc)
	  * @see gov.nih.nci.ServiceTestCase#getTestID()
	  */
	 @Override
	 protected String getTestID()
	 {
		 return testID;
	 }


	 /**
	  * Test metadata.
	  * 
	  * @throws Exception the exception
	  */
	 public void testMetadata() throws Exception
	 {

		 Boolean retval = adapter.setVocabulary(csName, version, null);
		 if (retval == null || !retval.equals(Boolean.TRUE))
		 {
			 System.out.println("Unable to connect - program aborts.");
			 fail("Could not set vocabulary");
			 return;
		 }
	 }

	 /**
	  * Test get namespace id.
	  */
	 public void testgetNamespaceID()
	 {
		 try{
			 //public Integer getNamespaceId(String csName,String version, String tag)
			 Integer namespaceId_test = adapter.getNamespaceId(csName, version, tag);
			 assertTrue("getNamespaceId(String,String,String)",namespaceId_test > 0);
			 assertTrue("getNamespaceId(String namespaceName)",namespaceId_test > 0);
			 //public int getNamespaceId(String namespaceName)
			 int namespaceId = adapter.getNamespaceId(csName);
//			 Integer int_obj = new Integer(namespaceId);
			 assertTrue("getNamespaceId(String namespaceName)",namespaceId > 0);
		 }
		 catch(Exception e){
			 fail("Exception thrown :" + e.getMessage());
		 }}

	 /**
	  * Test find namespace by code.
	  * 
	  * @deprecated
	  */@Deprecated
	  public void testFindNamespaceByCode()
	  {try{
		  int namespaceId = adapter.getNamespaceId(csName);
		  Integer int_obj = new Integer(namespaceId);
		  //public String findNamespaceByCode(String namespaceCode)
		  String namespaceName_test = adapter.findNamespaceByCode(int_obj.toString());
		  assertTrue("findNamespaceByCode(String)",namespaceName_test.length() > 0);
	  }
	  catch(Exception e){
		  fail("Exception thrown :" + e.getMessage());
	  }}

	  /**
	   * Testget vocabulary description.
	   */
	  public void testgetVocabularyDescription()
	  {
		  //public String getVocabularyDescription(String csName)
		  String csDesc = adapter.getVocabularyDescription(csName);
		  assertTrue("getVocabularyDescription(String)",csDesc.length() > 0);
	  }

	  /**
	   * Testget local names.
	   */
	  public void testgetLocalNames()
	  {try{
		  // Vector getLocalNames(String codingSchemeName)
		  Vector v = adapter.getLocalNames(csName);
		  assertTrue("getLocalNames(String)",v.size() > 0);
	  }
	  catch(Exception e){
		  fail("Exception thrown :" + e.getMessage());
	  }}

	  /**
	   * Testget represents version.
	   */
	  public void testgetRepresentsVersion()
	  {
		  // String getRepresentsVersion(String codingSchemeName)
		  String vers = adapter.getRepresentsVersion(csName);
		  assertTrue("getVersion(String)",vers.length() > 0);
	  }
//	  TODO Enter this as GForge bug
	  /**
	   * Testget metadata properties.
	   */
	  public void testgetMetadataProperties()
	  {
		  NameAndValue[] nv_array = adapter.getMetadataProperties(ServiceTestCase.THES_URN);
		  assertTrue("getMetadataProperties(String)",nv_array.length > 0);
		  for (int j=0; j<nv_array.length; j++)
		  {
			  NameAndValue nv = (NameAndValue) nv_array[j];
			  assertTrue("Metadata Name is returned", nv.getName().length()>0);
			  // KLO, 101907 (some property such as emailType can be null)
			  //assertTrue("Metadata Value is returned", nv.getContent().length()>0);
		  }
	  }

	  /**
	   * Testget vocabulary versions.
	   */
	  public void testgetVocabularyVersions()
	  {
		  // Vector getVocabularyVersions(String vocabularyname)
		  Vector v = adapter.getVocabularyVersions(csName);
		  assertNotNull("getVocabularyVersions(String )", v);
		  assertTrue("getVocabularyVersions has values", v.size() > 0);
	  }

	  /**
	   * Testget vocabulary tags.
	   */
	  public void testgetVocabularyTags()
	  {
		  //Vector getVocabularyTags(String vocabularyname, String version)
		  Vector v = adapter.getVocabularyTags(csName, version);
		  assertNotNull("getVocabularyTags(String,String)", v);
		  assertTrue("getVocabularyTags has values", v.size() > 0);
	  }

	  /**
	   * Testcoding scheme exists.
	   */
	  public void testcodingSchemeExists()
	  {
		  //boolean codingSchemeExists(String codingSchemeName)
		  //Boolean bool_val = adapter.codingSchemeExists(csName);
		  //TODO should alternate names work?
		  Boolean bool_val = adapter.codingSchemeExists(THES_LOCAL);
		  assertTrue("codingSchemeExists(String)", bool_val.booleanValue());
		  bool_val = adapter.codingSchemeExists("MyCodingScheme");
		  assertFalse("codingSchemeExists(String) false value", bool_val.booleanValue());
	  }

	  /**
	   * Testget vocabulary version.
	   */
	  public void testgetVocabularyVersion()
	  {
		  // String getVocabularyVersion(String name)
		  String versionName = adapter.getVocabularyVersion(csName);
		  assertTrue("getVocabularyVersion(String)", versionName.length()>0);
	  }

	  /**
	   * Testget supported concept association names_ string.
	   */
	  public void testgetSupportedConceptAssociationNames_String()
	  {
		  // Vector getSupportedConceptAssociationNames(String codingSchemeName)
		  Vector v = adapter.getSupportedConceptAssociationNames(csName);
		  assertNotNull("getSupportedConceptAssociationNames(String)", v);
		  assertTrue("getSupportedConceptAssociationNames(String) has values", v.size() > 0);
	  }

//	  TODO Report this as a bug in GForge
	  /**
	   * Testget all licenses.
	   */
	  public void testgetAllLicenses()
	  {try{
		  // Vector getAllLicenses()
		  Vector v = adapter.getAllLicenses();
		  assertTrue("getAllLicenses()", v.size()>0);
	  }
	  catch(Exception e){
		  fail("Exception thrown :" + e.getMessage());
	  }}

	  /**
	   * Testget vocabulary names.
	   */
	  public void testgetVocabularyNames()
	  {
		  //Vector getVocabularyNames()
		  Vector v = adapter.getVocabularyNames();
		  assertNotNull("getVocabularyNames()", v);
		  assertTrue("getVocabularyNames() has values", v.size() > 0);
	  }

	  /**
	   * Testget supported search techniques.
	   */
	  public void testgetSupportedSearchTechniques()
	  {
		  // public Vector getSupportedSearchTechniques()
		  Vector v = adapter.getSupportedSearchTechniques();
		  assertNotNull("getSupportedSearchTechniques()", v);
		  assertTrue("getSupportedSearchTechniques() has values", v.size() > 0);
	  }

	  /**
	   * Testget versions.
	   */
	  public void testgetVersions()
	  {
		  adapter.setVocabulary(ServiceTestCase.THES_SCHEME);

		  // Vector getVersions()
		  Vector v = adapter.getVersions();
		  assertTrue("getVersions()", v.size()>0);
	  }

	  /**
	   * Testget license.
	   */
	  public void testgetLicense()
	  {try{
		  DLBAdapter l_adapter = new DLBAdapter(AdapterServiceHolder.getEVSsvc());
		  l_adapter.setVocabulary(META_SCHEME);
		  // String getLicense()
		  String license = l_adapter.getLicense();
		  assertTrue("getLicense()", license.length()>0);
	  }
	  catch(Exception e){
		  fail("Exception thrown :" + e.getMessage());
	  }}

	  /**
	   * Testget supported concept status.
	   */
	  public void testgetSupportedConceptStatus()
	  {try{
		  // Vector getSupportedConceptStatus()
		  Vector v = adapter.getSupportedConceptStatus();
		  assertNotNull("getSupportedConceptStatus()", v);
		  assertTrue("getSupportedConceptStatus has values", v.size() > 0);
	  }
	  catch(Exception e){
		  fail("Exception thrown :" + e.getMessage());
	  }}

	  /**
	   * Testget all qualifier types.
	   */
	  public void testgetAllQualifierTypes()
	  {
//		  TODO report in GForge as bug
		  // Vector getAllQualifierTypes()
		  Vector v = adapter.getAllQualifierTypes();
		  assertNotNull("getAllQualifierTypes()", v);
		  assertTrue("getAllQualifierTypes() has values", v.size() > 0);
	  }

	  /**
	   * Testget all concept property qualifier types.
	   */
	  public void testgetAllConceptPropertyQualifierTypes()
	  {
//		  TODO report as bug in GForge
		  // Vector getAllConceptPropertyQualifierTypes()
		  Vector v = adapter.getAllConceptPropertyQualifierTypes();
		  assertNotNull("getAllConceptPropertyQualifierTypes()", v);
		  assertTrue("getAllConceptPropertyQualifierTypes() has values", v.size() > 0);
	  }
//	  TODO report as bug in GForge
	  //Vector getConceptPropertyQualifierTypes()
	  /**
	   * Testget concept property qualifier types.
	   */
	  public void testgetConceptPropertyQualifierTypes()
	  {
		  Vector v = adapter.getConceptPropertyQualifierTypes();
		  assertNotNull("getConceptPropertyQualifierTypes()", v);
		  assertTrue("getConceptPropertyQualifierTypes() has values", v.size() > 0);
	  }
//	  TODO report as bug in GForge
	  //Vector getSupportedPropertyQualifiers()
	  /**
	   * Testget supported property qualifiers.
	   */
	  public void testgetSupportedPropertyQualifiers()
	  {try{
		  Vector v = adapter.getSupportedPropertyQualifiers();
		  assertNotNull("getSupportedPropertyQualifiers()", v);
		  assertTrue("getSupportedPropertyQualifiers() has values", v.size() > 0);
	  }
	  catch(Exception e){
		  fail("Exception thrown :" + e.getMessage());
	  }}
	  //Vector getAllConceptAssociationQualifierTypes()
	  /**
	   * Testget all concept association qualifier types.
	   */
	  public void testgetAllConceptAssociationQualifierTypes()
	  {
		  Vector v = adapter.getAllConceptAssociationQualifierTypes();
		  assertNotNull("getAllConceptAssociationQualifierTypes()", v);
		  assertTrue("getAllConceptAssociationQualifierTypes() has values", v.size() > 0);
	  }
	  //Vector getConceptAssociationQualifierTypes()
	  /**
	   * Testget concept association qualifier types.
	   */
	  public void testgetConceptAssociationQualifierTypes()
	  {
		  Vector v = adapter.getConceptAssociationQualifierTypes();
		  assertNotNull("getConceptAssociationQualifierTypes()", v);
		  assertTrue("getConceptAssociationQualifierTypes() has values", v.size() > 0);
	  }
	  //RoleType[] getAllRoleTypesInNamespace()
	  /**
	   * Testget all role types in namespace.
	   */
	  public void testgetAllRoleTypesInNamespace()
	  {
		  RoleType[] types = adapter.getAllRoleTypesInNamespace();
		  assertTrue("getAllRoleTypesInNamespace() has values", types.length > 0);
	  }
	  // RoleType getRoleTypeById(int roleId)
	  /**
	   * Testget role type by id.
	   */
	  public void testgetRoleTypeById()
	  {
		  RoleType rt = adapter.getRoleTypeById(0);
		  assertNotNull("getRoleTypeById(int)", rt);
	  }
	  // PropertyType getPropertyTypeById(int propertyId)
	  /**
	   * Testget property type by id.
	   */
	  public void testgetPropertyTypeById()
	  {try{
		  PropertyType pt = adapter.getPropertyTypeById(0);
		  assertNotNull("getPropertyTypeById(int)", pt);
	  }
	  catch(Exception e){
		  fail("Exception thrown :" + e.getMessage());
	  }}
	  // Vector getAllConceptPropertyTypes(i)
	  /**
	   * Test get All Concept Property Types
	   */
	  public void getAllConceptPropertyTypes()
	  {try{
		  Vector pt = adapter.getAllConceptPropertyTypes();
		  assertNotNull("getPropertyTypeById(int)", pt);
	  }
	  catch(Exception e){
		  fail("Exception thrown :" + e.getMessage());
	  }}
	  // Vector getSupportedSources()
	  /**
	   * Testget supported sources.
	   */
	  public void testgetSupportedSources()
	  {try{
		  Vector v = adapter.getSupportedSources();
		  assertNotNull("getSupportedSources()", v);
		  assertTrue("getSupportedSources() has values", v.size() > 0);
	  }
	  catch(Exception e){
		  fail("Exception thrown :" + e.getMessage());
	  }}
	  // Vector getSupportedAssociationNames()
	  /**
	   * Test get supported association names.
	   */
	  public void testgetSupportedAssociationNames()
	  {try{
		  Vector v = adapter.getSupportedAssociationNames();
		  assertNotNull("getSupportedAssociationNames()", v);
		  assertTrue("getSupportedAssociationNames() has values", v.size() > 0);
	  }
	  catch(Exception e){
		  fail("Exception thrown :" + e.getMessage());
	  }}
	  // Vector getSupportedConceptAssociationNames()
	  /**
	   * Testget supported concept association names.
	   */
	  public void testgetSupportedConceptAssociationNames()
	  {
		  Vector v = adapter.getSupportedConceptAssociationNames();
		  assertNotNull("getSupportedConceptAssociationNames()", v);
		  assertTrue("getSupportedConceptAssociationNames() has values", v.size() > 0);
	  }
	  // Vector getSupportedRoleNames()
	  /**
	   * Testget supported role names.
	   */
	  public void testgetSupportedRoleNames()
	  {
		  Vector v = adapter.getSupportedRoleNames();
		  assertNotNull("getSupportedRoleNames()", v);
		  assertTrue("getSupportedRoleNames() has values", v.size() > 0);
	  }
	  // Vector getConceptAssociationTypes()
	  /**
	   * Testget concept association types.
	   */
	  public void testgetConceptAssociationTypes()
	  {
		  Vector v = adapter.getConceptAssociationTypes();
		  assertNotNull("getConceptAssociationTypes()", v);
		  assertTrue("getConceptAssociationTypes() has values", v.size() > 0);
	  }
	  // Vector getAllAssociationTypes()
	  /**
	   * Testget all association types.
	   */
	  public void testgetAllAssociationTypes()
	  {try{
		  Vector v = adapter.getAllAssociationTypes();
		  assertNotNull("getAllAssociationTypes()", v);
		  assertTrue("getAllAssociationTypes() has values", v.size() > 0);
	  }
	  catch(Exception e){
		  fail("Exception thrown :" + e.getMessage());
	  }}
	  //Vector getAllConceptAssociationTypes()
	  /**
	   * Testget all concept association  types.
	   */
	  public void testgetAllConceptAssociationTypes()
	  {
		  Vector v = adapter.getAllConceptAssociationTypes();
		  assertNotNull("getAllConceptAssociationTypes()", v);
		  assertTrue("getAllConceptAssociationTypes() has values", v.size() > 0);
	  }
	  // RoleType getRoleTypeByName(String rolename)
	  /**
	   * Test get role type by name.
	   */
	  public void testgetRoleTypeByName()
	  {
		  String rolename = "Technique_Has_Sample_Or_Specimen_Anatomy";

		  RoleType roletype = adapter.getRoleTypeByName(rolename);
		  assertNotNull("getRoleTypeByName(String)", roletype);
	  }
	  // PropertyType getPropertyTypeByName(String propertyName)
	  /**
	   * Test get property type by name.
	   */
	  public void testgetPropertyTypeByName()
	  {try{
		  String propertyname = "Semantic_Type";

		  PropertyType propertyType = adapter.getPropertyTypeByName(propertyname);
		  assertNotNull("getPropertyTypeByName(String)", propertyType);
	  }
	  catch(Exception e){
		  fail("Exception thrown :" + e.getMessage());
	  }}

	  //KLO 101907 (No SupportedContext data available according to direct LexBIG API calls)..

//	  TODO report as bug in GForge
	  // Vector getSupportedContextCount()
	  /**
	   * Testget supported context count.
	   */
	  public void testgetSupportedContextCount()
	  {try{
		  int n = adapter.getSupportedContextCount();
		  //assertTrue("getSupportedContextCount()", n > 0);
		  assertTrue("getSupportedContextCount()", n >= 0);
	  }
	  catch(Exception e){
		  fail("Exception thrown :" + e.getMessage());
	  }}
//	  TODO report as bug in GForge
	  /**
	   * Testget supported context.
	   */
	  public void testgetSupportedContext()
	  {try{
		  Vector v = adapter.getSupportedContext();
		  assertNotNull("getSupportedContext()", v);
		  //assertTrue("getSupportedContext() has values", v.size() > 0);
	  }
	  catch(Exception e){
		  fail("Exception thrown :" + e.getMessage());
	  }}

 }
