package gov.nih.nci.lexbig.ext.objects;

import static org.junit.Assert.*;
import gov.nih.nci.ServiceTestCase;
import gov.nih.nci.lexbig.ext.AdapterServiceHolder;
import gov.nih.nci.lexbig.ext.ConceptHistory;
import gov.nih.nci.lexbig.ext.DLBAdapter;
import gov.nih.nci.lexbig.ext.EditActionDate;

import java.sql.Date;
import java.util.Vector;

import org.junit.Test;

public class ConceptHistoryTest extends ServiceTestCase {

	final static String testID = "ConceptHistoryTest";
	DLBAdapter adapter = AdapterServiceHolder.instance().getDLBAdapter();
	private String conceptCode = "C68805";
	ConceptHistory ch = new ConceptHistory();
	ConceptHistory setCh = new ConceptHistory();
	
	public ConceptHistoryTest()
	{
		ch = adapter.getConceptHistory(conceptCode);
	}
	
    /* (non-Javadoc)
     * @see gov.nih.nci.evs.EVSQueryServiceTestCase#getTestID()
     */
    @Override
    protected String getTestID()
    {
        return testID;
    }

	@Test
	public void testSetCode() {
		fail("Not yet implemented");
	}

	@Test
	public void testSetName() {
		fail("Not yet implemented");
	}

	@Test
	public void testSetNamespaceId() {
		fail("Not yet implemented");
	}

	@Test
	public void testSetCreationDate() {
		fail("Not yet implemented");
	}

	@Test
	public void testSetIsRetired() {
		fail("Not yet implemented");
	}

	@Test
	public void testAddEditActionDate() {
		fail("Not yet implemented");
	}

	@Test
	public void testGetCode() {
		String code = ch.getCode();
		assertNotNull("Code returned", code);
		assertTrue("Code has value", code.length()>0);
		assertTrue("Code matches input", code.equals(conceptCode));
	}

	@Test
	public void testGetName() {
		String name = ch.getName();
		assertNotNull("name returned", name);
		assertTrue("name has value", name.length()>0);
	}

	@Test
	public void testGetNamespaceId() {
		Integer nsid = ch.getNamespaceId();
		assertNotNull("nsid returned", nsid);
		assertTrue("nsid has value", nsid>0);
	}

	@Test
	public void testGetCreationDate() {
		Date date = ch.getCreationDate();
		assertNotNull("name returned", date);
		assertTrue("name has value", date.toLocaleString().length()>0);
	}

	@Test
	public void testGetIsRetired() {
		assertFalse("Concept is not retired",ch.getIsRetired());
	}

	@Test
	public void testGetEditActionDates() {
		Vector<EditActionDate> dates = ch.getEditActionDates();
		assertNotNull("Vector of dates returned", dates);
		assertTrue("Vactor has values", dates.size()>0);
	}

}
