package gov.nih.nci.lexbig.ext.roles;

import java.util.Vector;

import org.LexGrid.concepts.CodedEntry;

import gov.nih.nci.lexbig.ext.DLBAdapter;
import gov.nih.nci.lexbig.ext.Role;
import gov.nih.nci.lexbig.ext.RoleType;
import gov.nih.nci.ServiceTestCase;
import gov.nih.nci.lexbig.ext.AdapterServiceHolder;

// TODO: Auto-generated Javadoc
/**
 * The Class RolesTest.
 */
public class RolesTest extends ServiceTestCase{

	/** The Constant testID. */
	final static String testID = "RolesTest";
	
	/** The role_name. */
	String role_name = "Anatomic_Structure_Is_Physical_Part_Of";
	
	/** The role_value. */
	String role_value = "C12419";
	
	/** The Concept_in. */
	String Concept_in = "C12220";
	
	/** The is code. */
	boolean isCode = false;
	
	/** The role_source. */
	String role_source = "C12220";

	/** The search_code. */
	String search_code = "C63923";
	
	/** The subconcept code. */
	String subconceptCode = "C12220";
	
	/** The code. */
	String code = subconceptCode;
	
	/** The assoname. */
	String assoname = "Concept_In_Subset";

	/** The asso_source. */
	String asso_source = "C192";

	/** The association code. */
	String associationCode = asso_source;
	
	/** The assoc target code. */
	String assocTargetCode = search_code;
	
	/** The role code. */
	String roleCode = role_source;

	/** The role_name_inv_role. */
	String role_name_inv_role = "Chemotherapy_Regimen_Has_Component";
	
	/** The role_target_inv_role. */
	String role_target_inv_role = "C488";  //Amifostine Trihydrate
	
	/** The role_source_inv_role. */
	String role_source_inv_role = "C11352";  //Amifostine/Cisplatin/Cytarabine/Dexamethasone

	/** The v. */
	Vector v = new Vector();

	/** The adapter. */
	DLBAdapter adapter = AdapterServiceHolder.instance().getDLBAdapter();
	
	/** The cs name. */
	String csName = ServiceTestCase.THES_SCHEME;
	
	/** The version. */
	String version = ServiceTestCase.THES_VERSION;
	
	/** The tag. */
	String tag = ServiceTestCase.THES_TAG;
	
	/** The ce. */
	CodedEntry ce = new CodedEntry();


	/** The bool_obj. */
	Boolean bool_obj = new Boolean(false);
	
	/* (non-Javadoc)
	 * @see gov.nih.nci.ServiceTestCase#getTestID()
	 */
	@Override
	protected String getTestID()
	{
		return testID;
	}

	/**
	 * Test roles.
	 * 
	 * @throws Exception the exception
	 */
	public void testRoles() throws Exception
	{
		Boolean retval = adapter.setVocabulary(csName, version, tag);
		if (retval == null || !retval.equals(Boolean.TRUE))
		{
			System.out.println("Unable to connect - program aborts.");
			fail("Could not connect");
			return;
		}
	}
	/*
			String role_name = "EncodedByGene";
			String role_value = "FRS2_Gene";
			String TargetConceptCode = "C24819"; //FRS2_Gene
			String Concept_in = "FGFR_Signalling_Adaptor";
			String ConceptCode_in = "C29587";  //FGFR_Signalling_Adaptor
//			boolean isCode = true;
			String role_source = "FGFR_Signalling_Adaptor";
//			String code_fetched = "C24819";  //FRS2_Gene
			String subconceptName = "FRS2_Gene";
			String pattern = "Heart";
			String associationCode = "C48323";  //Black
			String assocTargetCode = "C54453";  //Structured_Product_Labeling_Terminology
			String roleCode = "C12727"; //Heart
			int searchLimit = 10;
//			String search_code = "C15321";  //Research_Resources
//			String subconceptCode = "C24819";  //FRS2_Gene
//			String code = "";
			String superconceptCode = "C25997";  //Adaptor_Signaling_Protein_Gene
			String assoname = "Concept_In_Subset";
			String roleName = "Gene_Product_Encoded_By_Gene";
			String inverseRoleName = "Gene_Product_Encoded_By_Gene";
	 */


	/**
	 * Testget all role types.
	 */
	public void testgetAllRoleTypes()
	{
		// RoleType[] getAllRoleTypes()
		RoleType[] roles = adapter.getAllRoleTypes();
		assertNotNull("getAllRoleTypes()", roles);
		assertTrue("getAllRoleTypes() has values",roles.length>0);
	}

	/**
	 * Test contains inverse role.
	 */
	public void testContainsInverseRole_StringStringStringBool(){
		boolean is_code_inv_role = true;

//		bool_obj = adapter.containsInverseRole(role_name_inv_role,
//				role_target_inv_role,
//				role_source_inv_role,
//				is_code_inv_role);
		bool_obj = adapter.containsInverseRole(role_name_inv_role,
				role_source_inv_role,
				role_target_inv_role,
				is_code_inv_role);

		assertNotNull("containsInverseRole(String,String,String,boolean)", bool_obj);

		assertTrue("containsInverseRole(String,String,String,boolean) has values",bool_obj);
	}

	/**
	 * Test contains inverse role.
	 */
	public void testContainsInverseRole_StringStringString(){

		bool_obj = adapter.containsInverseRole(role_name_inv_role,
				role_target_inv_role,
				role_source_inv_role);
		
		bool_obj = adapter.containsInverseRole(role_name_inv_role,
				role_source_inv_role,
				role_target_inv_role);
		
		assertNotNull("containsInverseRole(String,String,String,boolean)", bool_obj);

		assertTrue("containsInverseRole(String,String,String,boolean) has values",bool_obj);
	}
	
	/**
	 * Test get all role names.
	 */
	public void testGetAllRoleNames(){
//		Vector getAllRoleNames()
		v = adapter.getAllRoleNames();
		assertNotNull("getAllRoleNames()", v);
		assertTrue("getAllRoleNames() has values",v.size()>0);
	}

	/**
	 * Test get all role names_ meta.
	 */
	public void testGetAllRoleNames_Meta(){

//		Vector getAllRoleNames(String codingScheme)
		DLBAdapter l_adapter = new DLBAdapter(AdapterServiceHolder.getEVSsvc());
		l_adapter.setVocabulary(META_SCHEME);
		v = l_adapter.getAllRoleNames(ServiceTestCase.META_SCHEME);
		assertNotNull("getAllRoleNames(String)", v);
		assertTrue("getAllRoleNames(String) has values",v.size()>0);
	}

	/**
	 * Test get roles by concept name.
	 */
	public void testGetRolesByConceptName(){

//		Vector getRolesByConceptName(String conceptname)
		v = adapter.getRolesByConceptName(role_source);
		assertNotNull("getRolesByConceptName(String)", v);
		assertTrue("getRolesByConceptName(String) has values",v.size()>0);
	}

	/**
	 * Test get roles by concept name.
	 */
	public void testGetRolesByConceptCode(){

//		Vector getRolesByConceptName(String conceptcode)
		Vector<Role> roles = adapter.getRolesByConceptCode(role_source);
		assertNotNull("getRolesByConceptCode(String)", roles);
		assertTrue("getRolesByConceptCode(String) has values",roles.size()>0);
	}
	
	/**
	 * Test contains role.
	 */
	public void testContainsRole_StringStringStringBool(){
//		public Boolean containsRole(String role_name, String role_value, String Concept_in, boolean isCode)
		bool_obj = adapter.containsRole(role_name, role_value, Concept_in, true);
		assertNotNull("containsRole(String,String,String,boolean)", bool_obj);
		assertTrue("containsRole(String,String,String,boolean) has values",bool_obj);

	}

	/**
	 * Test contains role.
	 */
	public void testContainsRole_StringStringString(){
//		public Boolean containsRole(String role_name, String role_value, String Concept_in, boolean isCode)
		bool_obj = adapter.containsRole(role_name, role_value, Concept_in);
		assertNotNull("containsRole(String,String,String,boolean)", bool_obj);
		assertTrue("containsRole(String,String,String,boolean) has values",bool_obj);

	}
	
	/**
	 * Test get fetched roles.
	 */
	public void testGetFetchedRoles_Stringboolean() {
//		Vector getFetchedRoles(String Concept_in, boolean isCode)
		v = adapter.getFetchedRoles(role_source, true);
		assertNotNull("getFetchedRoles(String,boolean)", v);
		assertTrue("getFetchedRoles(String,boolean) has values",v.size()>0);
	}

	/**
	 * Test get fetched roles.
	 */
	public void testGetFetchedRoles_StringStringboolean() {

//		Vector getFetchedRoles(String codingSchemeName, String Concept_in, boolean isCode)
		v = adapter.getFetchedRoles(csName, role_source, true);
		assertNotNull("getFetchedRoles(String,String,boolean)", v);
		assertTrue("getFetchedRoles(String,String,boolean) has values",v.size()>0);
	}
	
	/**
	 * Test get number of specified roles.
	 */
	public void testGetNumberOfSpecifiedRoles(){
//		int getNumberOfSpecifiedRoles(String Concept_in)
		int n = adapter.getNumberOfSpecifiedRoles(role_source);
		assertTrue("getNumberOfSpecifiedRoles(String)",n>0);
	}

	/**
	 * Test get fetched inverse roles.
	 */
	public void testGetFetchedInverseRoles_String(){
//		Vector getFetchedInverseRoles(String Concept_in)
		v = adapter.getFetchedInverseRoles(role_source);
		assertNotNull("getFetchedInverseRoles(String)", v);
		assertTrue("getFetchedInverseRoles(String) has values",v.size()>0);

//		Vector getFetchedInverseRoles(String Concept_in)
		v = adapter.getFetchedInverseRoles(role_target_inv_role);
		assertNotNull("getFetchedInverseRoles(String)", v);
		assertTrue("getFetchedInverseRoles(String) has values",v.size()>0);
	}
	/**
	 * Test get fetched inverse roles.
	 */
	public void testGetFetchedInverseRoles_Stringboolean(){
//		Vector getFetchedInverseRoles(String Concept_in, boolean isCode)
		v = adapter.getFetchedInverseRoles(role_target_inv_role, true);
		assertNotNull("getFetchedInverseRoles(String, boolean)", v);
		assertTrue("getFetchedInverseRoles(String, boolean) has values",v.size()>0);
	}
	/**
	 * Test get fetched inverse roles.
	 */
	public void testGetFetchedInverseRoles_StringStringboolean(){
//		Vector getFetchedInverseRoles(String codingSchemeName, String Concept_in, boolean isCode)
		v = adapter.getFetchedInverseRoles(csName, role_target_inv_role, true);
		assertNotNull("getFetchedInverseRoles(String,String,boolean)", v);
		assertTrue("getFetchedInverseRoles(String,String, boolean) has values",v.size()>0);
	}
	/**
	 * Test get number of specified inverse roles.
	 */
	public void testGetNumberOfSpecifiedInverseRoles(){
//		Integer getNumberOfSpecifiedInverseRoles(String Concept_in)
		int n = adapter.getNumberOfSpecifiedInverseRoles(subconceptCode);
		assertTrue("getNumberOfSpecifiedInverseRoles(String)",n>0);

//		Integer getNumberOfSpecifiedInverseRoles(String Concept_in)
		n = adapter.getNumberOfSpecifiedInverseRoles(role_target_inv_role);
		assertTrue("getNumberOfSpecifiedInverseRoles(String)",n>0);
	}

	/**
	 * Test get number by coded entry.
	 */
	public void testGetNumberOfRolesByCodedEntry(){
		ce = adapter.findConceptByCode(roleCode);

		int j = adapter.getNumberOfSpecifiedRoles(ce.getConceptCode());
		if (j>0)
		{
			v = adapter.getRoles(ce);
			assertNotNull("getRoles(CodedEntry)", v);
			assertTrue("getRoles(CodedEntry) has values",v.size()>0);

			//Vector getRoles(String codeingScheme, String version, CodedEntry ce)
			v = adapter.getRoles(csName, version, tag, ce);
			assertNotNull("getRoles(String,String,String,CodedEntry)", v);
			assertTrue("getRoles(String,String,String,CodedEntry) has values",v.size()>0);

		}

		j = adapter.getNumberOfSpecifiedInverseRoles(ce.getConceptCode());
		if (j>0)
		{
			//Vector getInverseRoles(String codeingScheme, String version, CodedEntry ce)
			v = adapter.getInverseRoles(csName, version, tag, ce);
			assertNotNull("getInverseRoles(String,String,String,CodedEntry)", v);
			assertTrue("getInverseRoles(String,String,String,CodedEntry) has values",v.size()>0);
		}
	}

	/**
	 * Test get concept associations.
	 */
	public void testGetConceptAssociations_CodedEntry(){
		ce = adapter.getCodedEntryByCode(csName, version, tag, associationCode);
//		TODO enter feature request to get number of associations that are not roles
//		Vector getConceptAssociations(CodedEntry ce)

		ce = adapter.getConcept(csName, asso_source, 1);
		v = adapter.getConceptAssociations(ce);
		assertNotNull("getConceptAssociations(CodedEntry)", v);
		assertTrue("getConceptAssociations(CodedEntry) has values",v.size()>0);
	}

	/**
	 * Test get concept associations.
	 */
	public void testGetConceptAssociations_StringStringCodedEntry(){
		ce = adapter.getCodedEntryByCode(csName, version, tag, associationCode);
//		TODO enter feature request to get number of associations that are not roles
//		Vector getConceptAssociations(CodedEntry ce)

		ce = adapter.getConcept(csName, asso_source, 1);

//		Vector getConceptAssociations(String codingScheme, String version, CodedEntry ce)
		v = adapter.getConceptAssociations(csName, version, tag, ce);
		assertNotNull("getConceptAssociations(String,String,String,CodedEntry)", v);
		assertTrue("getConceptAssociations(String,String,String,CodedEntry) has values",v.size()>0);
	}

	
	/**
	 * Test get inverse concept associations.
	 */
	public void testGetInverseConceptAssociations_CodedEntry(){
		ce = adapter.findConceptByCode(assocTargetCode);
//		Vector getInverseConceptAssociations(CodedEntry ce)
		v = adapter.getInverseConceptAssociations(ce);
		assertNotNull("getInverseConceptAssociations(String,boolean)", v);
		assertTrue("getInverseConceptAssociations(String,boolean) has values",v.size()>0);
	}

	/**
	 * Test get inverse concept associations.
	 */
	public void testGetInverseConceptAssociations_StringStringStringCodedEntry(){
		ce = adapter.findConceptByCode(assocTargetCode);

//		Vector getInverseConceptAssociations(String codeingScheme, String version, CodedEntry ce)
		v = adapter.getInverseConceptAssociations(csName, version, tag, ce);
		assertNotNull("getInverseConceptAssociations(String,boolean)", v);
		assertTrue("getInverseConceptAssociations(String,boolean) has values",v.size()>0);
	}
	
	/**
	 * Test get role collection by code.
	 */
	public void testGetRoleCollectionByCode() {
//		Vector getRoleCollectionbyCode(String vocabularyName, String code) {
		v = adapter.getRoleCollectionbyCode(csName, role_source);
		assertNotNull("getRoleCollectionbyCode(String,String)", v);
		assertTrue("getRoleCollectionbyCode(String,String) has values",v.size()>0);

//		Vector getInverseRoleCollectionbyCode(String vocabularyName, String code) {
		v = adapter.getInverseRoleCollectionbyCode(csName, role_source);
		assertNotNull("getInverseRoleCollectionbyCode(String,String)", v);
		assertTrue("getInverseRoleCollectionbyCode(String,String) has values",v.size()>0);
	}

	/**
	 * Gets the association collection by code.
	 * 
	 * @return the association collection by code
	 */
	public void testGetAssociationCollectionByCode(){
//		Vector getAssociationCollectionbyCode(String vocabularyName, String code) {
		v = adapter.getAssociationCollectionbyCode(csName, associationCode);
		assertNotNull("getAssociationCollectionbyCode(String,String)", v);
		assertTrue("getAssociationCollectionbyCode(String,String) has values",v.size()>0);

//		Vector getInverseAssociationCollectionbyCode(String vocabularyName, String code) {
		v = adapter.getInverseAssociationCollectionbyCode(csName, assocTargetCode);
		assertNotNull("getInverseAssociationCollectionbyCode(String,String)", v);
		assertTrue("getInverseAssociationCollectionbyCode(String,String) has values",v.size()>0);
	}

	/**
	 * Test is association supported.
	 */
	public void testIsAssociationSupported(){
		boolean bool_val = adapter.isAssociationSupported(assoname);
		assertTrue("isAssociationSupported(String)",bool_val);
	}

	/**
	 * Test get fetched concept associations.
	 */
	public void testGetFetchedConceptAssociations_String(){
//		Vector getFetchedConceptAssociations(String code)
		v = adapter.getFetchedConceptAssociations(associationCode);
		assertNotNull("getFetchedConceptAssociations(String)", v);
		assertTrue("getFetchedConceptAssociations(String) has values",v.size()>0);
	}

	/**
	 * Test get fetched concept associations.
	 */
	public void testGetFetchedConceptAssociations_StringString(){

//		Vector getFetchedConceptAssociations(
		v = adapter.getFetchedConceptAssociations(csName, associationCode);
		assertNotNull("getFetchedConceptAssociations(String,String)", v);
		assertTrue("getFetchedConceptAssociations(String,String) has values",v.size()>0);
	}
	
	/**
	 * Test get association collection by code.
	 */
	public void testGetAssociationCollectionByCode2(){
		code = asso_source;

//		Vector getAssociationCollectionbyCode(String vocabularyName, String code) {
		v = adapter.getAssociationCollectionbyCode(csName, code);
		assertNotNull("getAssociationCollectionbyCode(String,String)", v);
		assertTrue("getAssociationCollectionbyCode(String,String) has values",v.size()>0);
	}

	/**
	 * Test get has subtype.
	 */
	public void testGetHasSubtype() {
		String is_a = adapter.getHasSubtype(csName);
		assertNotNull("getHasSubtype(String)", is_a);
		assertTrue("getHasSubtype(String) has values",is_a.length()>0);

		Boolean isforward = adapter.isForwardName(csName, version, is_a);
		assertTrue("isForwardName(String, String)",isforward);

		Boolean isreverse = adapter.isReverseName(csName, version, is_a);
		assertFalse("isReverseName(String, String)",isreverse);
	}

	/**
	 * Test roles_ zebrafish.
	 */
	public void testRoles_Zebrafish(){

		// need ZEBRAFISH_VERSION to test
		csName = ServiceTestCase.ZEBRAFISH_SCHEME;
		DLBAdapter l_adapter = new DLBAdapter(AdapterServiceHolder.getEVSsvc());
		l_adapter.setVocabulary(csName);

		String is_a = l_adapter.getHasSubtype(csName);
		Boolean isforward = l_adapter.isForwardName(csName, null, is_a);
		assertTrue("isForwardName(String, String)",isforward);

		Boolean isreverse = l_adapter.isReverseName(csName, null, is_a);
		assertFalse("isReverseName(String, String)",isreverse);

	}


}
