package gov.nih.nci.lexbig.ext.tree.hierarchy;

import gov.nih.nci.ServiceTestCase;
import gov.nih.nci.lexbig.ext.AdapterServiceHolder;
import gov.nih.nci.lexbig.ext.DLBAdapter;

import java.util.Vector;

import javax.swing.tree.DefaultMutableTreeNode;

/**
 * The Class TreeHierarchyTest.
 */
@SuppressWarnings("deprecation")
public class TreeHierarchyTest extends ServiceTestCase{

    final static String testID = "TreeHierarchyTest";

    @Override
    protected String getTestID()
    {
        return testID;
    }

    /**
     * Test tree hierarchy.
     * 
     * @throws Exception the exception
     */
    public void testTreeHierarchy() throws Exception
    {
    	//adapter.getTree(String rootname,boolean direction,int levels,int asdIndex,boolean isaFlag,Vector roleNames)
    	/*
		String rootname = "Heart";
		String rootCode = "C12727";
		//String rootname = "C191";
		boolean direction = true;
		int levels = -1;
		boolean isaflag = true;
		Vector<String> rolenames = new Vector<String>();
		rolenames.add("Technique_Has_Sample_Or_Specimen_Anatomy");
		DLBAdapter adapter = AdapterServiceHolder.instance().getDLBAdapter();
    	 */

    	DLBAdapter adapter = AdapterServiceHolder.instance().getDLBAdapter();
    	String csName = ServiceTestCase.THES_SCHEME;
    	String version = ServiceTestCase.THES_VERSION;
//    	String tag = ServiceTestCase.THES_TAG;

    	Boolean retval = adapter.setVocabulary(csName,version, null);
    	if (retval == null || !retval.equals(Boolean.TRUE))
    	{
    		System.out.println("Unable to connect - program aborts.");
    		return;
    	}

    	boolean direction = true;
    	int levels = -1;
    	boolean isaflag = true;
    	Vector<String> rolenames = new Vector<String>();
//  	rolenames.add("Technique_Has_Sample_Or_Specimen_Anatomy");


    	String rootname = "C12220";
    	rolenames.add("Anatomic_Structure_Is_Physical_Part_Of");

    	String rootCode = rootname;


    	//gov.nih.nci.lexrpc.client.AttributeSetDescriptor attributes = AttributeSetDescriptor.NO_ATTRIBUTES;

//  	adapter.setVocabulary(ServiceTestCase.THES_SCHEME, ServiceTestCase.THES_VERSION, ServiceTestCase.THES_TAG);
    	try{
    	DefaultMutableTreeNode dmtn = adapter.getTree(rootCode,
    			direction,
    			levels,
    			0,
    			isaflag,
    			rolenames);

    	assertNotNull("getTree(String,boolean,int,int,boolean,Vector) not null",dmtn);
    	assertTrue("getTree(String,boolean,int,int,boolean,Vector) returns result", dmtn.getLeafCount()>0);
    	}
    	catch (Exception e){
    		fail("Exception thrown");
    	}
    }
    	
    /**
     * Test tree hierarchy_ zebrafish.
     */
    public void testTreeHierarchy_Zebrafish(){
    	
	//getTree(String,boolean,int,int,String,Vector)
    	DLBAdapter adapter2 = new DLBAdapter(AdapterServiceHolder.instance().getEVSsvc());
    	Boolean setZF = adapter2.setVocabulary(ServiceTestCase.ZEBRAFISH_SCHEME, ServiceTestCase.ZEBRAFISH_VERSION, null);
    	assertTrue("able to set Zebrafish vocab", setZF.booleanValue());
    	boolean direction = true;
    	int levels = -1;
//    	boolean isaflag = true;
    	Vector<String> rolenames = new Vector<String>();
//    	rolenames.add("R1"); //"part_of"
    	String rootname = "ZFA_0000010";//cardiovascular_system


//		adaptertemp.setVocabulary("Zebrafish_ontology");
		String isaName = "isSubClassOf";  //"hasSubtype"
		try{
		DefaultMutableTreeNode dmt = adapter2.getTree(rootname,
				direction, 
				isaName, 
				rolenames);	
		
		assertNotNull("getTree(String,boolean,String,Vector) not null",dmt);
		assertTrue("getTree(String,boolean,String,Vector) returns result", dmt.getLeafCount()>0);

		
		DefaultMutableTreeNode dmtn = adapter2.getTree(rootname,
				direction,
				levels,
				0,
				isaName,
				rolenames);
		assertNotNull("getTree(String,boolean,int,int,String,Vector) not null",dmtn);
		assertTrue("getTree(String,boolean,int,int,String,Vector) returns result", dmtn.getLeafCount()>0);
		}
		catch (Exception e){
			fail("Exception thrown");
		}

    }

}
