package gov.nih.nci.performance;

import gov.nih.nci.evs.EVSQueryServiceHolder;
import gov.nih.nci.system.applicationservice.EVSApplicationService;

import org.LexGrid.LexBIG.Impl.testUtility.ServiceHolder;
import org.LexGrid.LexBIG.LexBIGService.LexBIGService;

/**
 * The Class PerformanceServiceHolder.
 */
public class PerformanceServiceHolder {
	   private EVSApplicationService  appService = null;
	   private LexBIGService lbsi;  //direct lexbig service
	   private LexBIGService dlbs; //distributed lexbig service

	   private static PerformanceServiceHolder sh_;
	
		/**
		 * Use this to set up the tests for end user enviroment validation. Only runs the tests once, using their
		 * normal config file.
		 */
		public static void configure()
		{
			sh_ = new PerformanceServiceHolder();
		}
	    
    	/**
    	 * Use this to get an instance of the ServiceHolder. If 'configureForSingleConfig' has not been called,
    	 * this will run the tests on all configured databases in the testConfig.props file.
    	 * 
    	 * @return the performance service holder
    	 */
	    public static PerformanceServiceHolder instance()
	    {
	        if (sh_ == null)
	        {
	            throw new RuntimeException("ServiceHolder has not been configured");
	            //sh_ = new ServiceHolder(true, false);
	        }
	        return sh_;

	    }
		private PerformanceServiceHolder()
		{
			EVSQueryServiceHolder.configure();
			appService=EVSQueryServiceHolder.instance().getAppService();
			ServiceHolder.configureForSingleConfig(true);
			dlbs = ServiceHolder.instance().getLexBIGService();
			ServiceHolder.configureForSingleConfig(false);
			lbsi = ServiceHolder.instance().getLexBIGService();
		}
		
		/**
		 * Gets the query instance.
		 * 
		 * @return the query instance
		 */
		public EVSApplicationService getQueryInstance()
		{
			return appService;
		}
		
		/**
		 * Gets the dLB instance.
		 * 
		 * @return the dLB instance
		 */
		public LexBIGService getDLBInstance()
		{
			return dlbs;
		}
		
		/**
		 * Gets the lex big instance.
		 * 
		 * @return the lex big instance
		 */
		public LexBIGService getLexBIGInstance()
		{
			return lbsi;
		}

}
