/*
 * Copyright: (c) 2004-2006 Mayo Foundation for Medical Education and
 * Research (MFMER).  All rights reserved.  MAYO, MAYO CLINIC, and the
 * triple-shield Mayo logo are trademarks and service marks of MFMER.
 *
 * Except as contained in the copyright notice above, the trade names, 
 * trademarks, service marks, or product names of the copyright holder shall
 * not be used in advertising, promotion or otherwise in connection with
 * this Software without prior written authorization of the copyright holder.
 * 
 * Licensed under the Eclipse Public License, Version 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at 
 * 
 * 		http://www.eclipse.org/legal/epl-v10.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.LexGrid.LexBIG.Impl;


import gov.nih.nci.ServiceTestCase;


/**
 * Base text fixture for LexBIGService initialization and result logging
 * <p>
 * This program assumes the sample content or a full version of the
 * NCI_Thesaurus been loaded using the admin tools.
 */
abstract public class LexBIGServiceTestCase extends ServiceTestCase {
	// Info for test vocabularies ...
	/** The Constant AUTO_SCHEME. */
	public final static String AUTO_SCHEME = "Automobiles";
	
	/** The Constant AUTO_URN. */
	public final static String AUTO_URN = "urn:oid:11.11.0.1";
	
	/** The Constant AUTO_VERSION. */
	public final static String AUTO_VERSION = "1.0";
	
	/** The Constant PARTS_SCHEME. */
	public final static String PARTS_SCHEME = "German Made Parts";
	
	/** The Constant PARTS_URN. */
	public final static String PARTS_URN = "urn:oid:11.11.0.2";
	
	/** The Constant PARTS_VERSION. */
	public final static String PARTS_VERSION = "2.0";

	/**
	 * To be implemented by each descendant testcase.
	 * 
	 * @return String
	 */
	abstract protected String getTestID();

}